          NBEAMS Neutral Beam Heating and Current Drive Module

ABSTRACT

The NBEAMS module contains routines for the calculation of neutral beam
heating and current drive quantities in tokamak plasmas. It calculates
the NB deposition profile, profiles of the NB heating power deposited to
the background ions and electrons, various NB current drive quantities and, 
optionally, several beam-target fusion quantities. 

This module was developed originally by the author for the ITER systems code 
"SuperCode" and it was used extensively during the ITER CDA and EDA designs.

The calculation is approximate (it is based on the diffuse beam approximation 
and it assumes a simplified flux surface geometry) but computationally fast.
The module is intended to be used in simulations where a realistic NB heating
profile is desired, but the full accuracy of more detailed (and computationally
expensive) codes such as NFREYA is not necessary.

CONTACT

   John Mandrekas
   Georgia Institute of Technology
   Fusion Research Center
   Atlanta, GA 30332-0225
   (404) 894-7730
   john.mandrekas@me.gatech.edu

UNPACKING INSTRUCTIONS

> gunzip nbeams.tar.gz
> tar xvf nbeams.tar

DOCUMENTATION

A GTFR (Georgia Tech Fusion Research) report is included in PDF and
postscript formats (nbeams.pdf and nbeams.ps) that explains the physical
models included in the nbeams module. Extensive comments in the beginning 
of the main routine (calcbeams.f) describe the input and output variables.

CONTENTS

The package should include the following files:

   README           : This file
   Makefile         : GNU Makefile for compiling the module
   nbdriver.f       : Driver file to test the module. This file is not
		      part of the package, but it is provided here in
		      order to create the necessary background plasma
		      and geometry required to test the module. The 
		      user can substitute his/her own driver.
   inbeams.dat      : Input file required by nbdriver
   calcbeams.f      : Main routine (this is the routine that one would
		      call from within a transport code)
   hofr.f           : Routine that calculates the NB deposition profile
   fastions.f       : Routine that calculates various fast ion quantities
   beams_mfp.f	    : Routine that calculates the mean free path of beam
		      neutrals in the background plasma
   sigfit.f         : Routine that calculates the beam stopping cross section
   sig_olson.f      : Routine that calculates the beam stopping cross section 
		      for species not included in the sigfit routine
   coulomb.f        : Routine that calculates Coulomb logarithms
   eisplit.f        : Routine that calculates the fraction of power deposited
		      to electrons and ions during the slowing down of a 
		      fast ion.
   erf.f            : Function to calculate the error function
   beamconsts.f     : Blockdata routine initializing constants in COMMON
   qsimp.f          : Routine to calculate integrals using Simpson's rule
   getrho.f         : Routine that finds the value of rho for a given R
   hunt.f           : Routine to perform searches (needed by getrho)
   frate.f          : Function to calculate reaction rates needed in the 
		      beam-target fusion calculations
   rinteg.f
   sinteg.f         : These three routines perform integrations along the
   zinteg.f	      R, Z and s directions of the beamline.
   gausswts.f       : Routine that calculates Gaussian weights for the 
		      R, Z and s integrations.
   ssum.f           : Auxiliary routine to sum the elements of a single
		      precision vector. Should not be used in platforms that
		      provide their own optimized version.
   nbparams.inc     : Common blocks internal to the module. The nbparams.inc
   nbplasma.inc       common block includes parameter statements for the 
		      dimensioning of several arrays.
   nbplasma.inc
   nbconsts.inc
   BeamsLoc.inc

EXTERNAL LIBRARIES

The module requires to be linked with the widely available BLAS library. If
this is a problem, the user can supply his/her own version of the SCOPY 
routine which copies one vector into another.

Some routines (erf.f, hunt.f and qsimp.f) have been adapted from the book
"Numerical Recipes".

INSTALLATION

No installation is required. This is a standard f77 code, and the executable
(xbeams) is created by simply typing "gmake" at the prompt (The GNU make is
reqiuired). The provided Makefile works on SUN/SunOS, SUN/Solaris, NERSC CRAYs 
and HP platforms, and can be modified to work on other systems.

The input file inbeams.dat contains a sample namelist input required by the
nbdriver program.

First NTCC Release:
September 7, 2000.

      real function erf(x)

c-----This function returns the error function ERF(x) with fractional
c-----error everywhere less than 1.2*10-7.
c-----Adapted from the book "Numerical Recipes"

      real x, z, t, erfcc
      if (x.lt.9.0) then
         z=abs(x)      
         t=1./(1.+0.5*z)
         erfcc=t*exp(-z*z-1.26551223+t*(1.00002368+t*(.37409196+
     *     t*(.09678418+t*(-.18628806+t*(.27886807+t*(-1.13520398+
     *     t*(1.48851587+t*(-.82215223+t*.17087277)))))))))
         if (x.lt.0.) erfcc=2.-erfcc
      endif
      if (x.ge.9.0) erfcc = 0.0
      erf = 1.0 - erfcc
      
      return
      end

c///////////////////////////////////////////////////////////////////////
c/
c/ NAME
c/    eiSplit
c/
c/ DESCRIPTION
c/    This routine calculates the fraction of energy deposited to
c/    plasma ions and electrons during the slowing down of a fast 
c/    ion in a plasma, assuming classical, instantaneous slowing
c/    down.
c/
c/ PARAMETERS
c/    fastEnergy : initial energy of fast ions in keV
c/    fastMass   : atomic mass of fast ions
c/
c/ RETURNS
c/    fion(i)    : vector with the fraction of the energy going
c/                 to plasma ions at zone -i-
c/    felec(i)   : vector with the fraction of the energy going
c/                 to plasma electrons.
c/
c/ CHANGES
c/    16-aug-00  : Changes in preparation for NTCC submission
c/
c///////////////////////////////////////////////////////////////////////

      subroutine eiSplit (fastEnergy, fastMass, fion, felec)

  
      implicit none
      
      include 'nbparams.inc'
      include 'nbconsts.inc'
      include 'nbplasma.inc'
      

c/    Local declarations:
c/    ------------------
      real fastEnergy, fastMass, fion(mxrho), felec(mxrho)
      real coulLoge, coulLogi, rterm, root3, sumbrack, term1, term2,
     .   twoThirds, ecrit, xcr, zbracket
      integer i, j
      
      root3 = Sqrt(3.0)
      twoThirds = 2.0/3.0
      do i = 1, nrho
         coulLoge = 37.8 + Log(elecTemp(i)/Sqrt(1.0e20*elecDensity(i)))
         rterm = Sqrt(elecTemp(i) * fastEnergy * fastMass /
     .      elecDensity(i))
         sumbrack = 0.0
	 do j = 1, nions
            coulLogi =  19.1 + Log((atw(j) / (fastMass+atw(j)))*rterm)
            sumbrack = sumbrack + dni(i,j) * znum(j)**2 
     .         * coulLogi / atw(j)
         enddo
         zbracket = sumbrack / (coulLoge * elecDensity(i))

c/    Critical energy for fast ion slowing down:
c/    -----------------------------------------
         ecrit = 14.8 * (zbracket**twoThirds) * fastMass * elecTemp(i)
         xcr = Sqrt(fastEnergy/ecrit)
         term1 = Log((xcr**2+2.*xcr+1.)/(xcr**2-xcr+1))/6.0
         term2 = (atan((2.*xcr-1)/root3) + pi/6.)/root3
         fion(i) = 2.0 * (term2 - term1) / (xcr**2)
         felec(i) = 1.0 - fion(i)
      enddo

      return
      end

c//////////////////////////////////////////////////////////////////////////
c/
c/ NAME
c/    rinteg
c/
c/ DESCRIPTION
c/    This routine calculates the part of the integral along the
c/    major radius R at a given plane Z=zb, for the integration
c/    on the face of the beam.
c/    Written by John Mandrekas, GIT, for the SuperCode
c/    Revisions:
c/    04-14-92, John Mandrekas:
c/       Modified to handle beams with three energy components more
c/       efficiently
c/    02-10-92, John Mandrekas:
c/       Reversed integration limits when calling SINTEG
c/       Defined -nstart- for better interaction with GETRHO
c/       Allowed for uniform power distribution in case of circular
c/        beams (rectangular beams already had this capability)
c/
c/ PARAMETERS
c/    None
c/
c/ RETURNS
c/    Nothing
c/
c/////////////////////////////////////////////////////////////////////////

      subroutine rinteg

      implicit none

      include 'nbparams.inc'
      include 'BeamsLoc.inc'
      include 'nbplasma.inc'
      
c/    Local variable declarations:
c/    ---------------------------
      integer ie, ir
      real rterm, rbterm, rwterm, rbin, rbout, rwin, rwout, rcut,
     .     rl, ru, ruprl, rumrl, sumr1, sumr2, sumr3, dblpass, rsml2,
     .     rtest, rtoler, rcoeff, pwrfact, pwrterm, pwzterm1, pwzterm2, 
     .     ksibeam, sumksi1, sumksi2, sumksi3, sumterm

      real  dterm(3)
      data rtoler /1.0e-05/
            
c/    Intersection of beam with zb plane (rbin, rbout):
c/    ------------------------------------------------
c/    shape=0: circular cross section
c/    shape=1: rectangular cross section

      if (shape.eq.0) then
         rbterm = Sqrt(rbeam**2 -zb**2)
      else if (shape.eq.1) then
         rbterm = 0.5*width
      endif

      rterm  = Sqrt(rhoi**2 - (zb/elongr)**2)
      rbin   = rtan - rbterm
      rbout  = rtan + rbterm
      rwterm = Sqrt(rhoSurf**2 - (zb/elonga)**2)
      rwin   = rmajor - rwterm 
      rwout  = rmajor + rwterm

c/    Intersection of flux surface -rho- with zb plane (rflux):

      rflux = rmajor + shft + sgn*rterm
      
c/    If rflux < rbin, no intersection of beamline with rho:

      if (rflux.le.rbin) then
         do ie = 1, 3
            alongr(ie) = 0.0
            alongksi(ie)= 0.0
         enddo
         return
      endif
      
c/    Calculate limits of -rb- integration:

      rl = rbin
      ru = min(rflux, rbout)
      
c/    Start coordinate transformations for Gaussian integration:

      ruprl = ru + rl
      rumrl = ru - rl
      
c/    Avoid very small integration intervals

      rtest = rumrl/ruprl
      if (rtest.lt.rtoler) then
         do ie = 1, 3
            alongr(ie) = 0.0
            alongksi(ie)= 0.0
         enddo
         return
      endif

c/    Start integration along R:

      sumr1 = 0.0
      sumr2 = 0.0
      sumr3 = 0.0
      sumksi1 = 0.0
      sumksi2 = 0.0
      sumksi3 = 0.0
      do ir = 1, nr
         rb = 0.5*(rumrl*sr(ir) + ruprl)
         ksibeam = rb/rflux
         
c/    Check for double pass, and calculate integral along beam path
         
         rcut = rflux   
         nstart = 0     ! needed by GETRHO
         call sinteg (rwout, rcut, capd0)
         if (rb.lt.rwin) then
            do ie = 1, 3
               capd1(ie) = 0.0
            enddo
            dblpass = 0.0
         else  
            call sinteg (rcut, rb, capd1)
            dblpass = 1.0
         endif
         do ie = 1, 3
            if (fbpwr(ie,ibeam).ne.0.0) then
               dterm(ie) = exp(capd0(ie)) + 
     .           dblpass*exp(capd0(ie) + 2.0*capd1(ie))
            endif
         enddo

c/    Power distribution on the surface of the beam:
c/    ---------------------------------------------
c/       ptype = 0: uniform distribution
c/       ptype = 1: Gaussian or bi-Gaussian

         if (shape.eq.0) then       
            if (ptype.eq.0) pwrfact = 1.0
            if (ptype.eq.1) then
               rsml2 = zb**2 + (rtan - rb)**2
               pwrfact = exp(-rsml2/(gaussR**2))
            endif
         else if (shape.eq.1) then
            if (ptype.eq.0) pwrfact = 1.0
            if (ptype.eq.1) then
               pwrterm  = (rb-rtan)/gaussR
               pwzterm1 = (zb-zpos)/gaussZ
               pwzterm2 = (zb+zpos)/gaussZ
               pwrfact  = exp(-pwrterm**2)*(
     .           exp(-pwzterm1**2) + exp(-pwzterm2**2))
            endif
         endif

         sumterm = rflux*pwrfact*Sqrt((1.0 - sr(ir)**2)/
     .             (rflux**2 - rb**2))
         sumr1 = sumr1 + sumterm*dterm(1)
         sumr2 = sumr2 + sumterm*dterm(2)
         sumr3 = sumr3 + sumterm*dterm(3)
         sumksi1 = sumksi1 + sumterm*dterm(1)*ksibeam
         sumksi2 = sumksi2 + sumterm*dterm(2)*ksibeam
         sumksi3 = sumksi3 + sumterm*dterm(3)*ksibeam
      enddo
      
      rcoeff = 0.5*rumrl*wr
      alongr(1) = rcoeff*sumr1
      alongr(2) = rcoeff*sumr2
      alongr(3) = rcoeff*sumr3
      alongksi(1) = rcoeff*sumksi1
      alongksi(2) = rcoeff*sumksi2
      alongksi(3) = rcoeff*sumksi3

      return
      end                        

      block data nbconsts

c/    This blockdata subprogram initializes several constants that are
c/    used in the NB module
      
      implicit none
      include 'nbconsts.inc'
      
      data pi /3.1415926536/, muZero /1.256637E-06/, 
     .     eCharge /1.6022e-19/
      
      end

c///////////////////////////////////////////////////////////////////////
c/ 
c/ NAME
c/    hunt
c/
c/ DESCRIPTION
c/    Routine for search with correlated values:
c/    Given an array xx of length n, and given a value x, this
c/    subroutine returns a value jlo, such that x is between
c/    xx(jlo) and xx(jlo+1). The array xx must be monotonic, either
c/    increasing or decreasing. On input, jlo is taken as the initial
c/    guess for jlo on output.
c/    Written by John Mandrekas, GIT, 02-02-92, for the SuperCode.
c/    Adapted from "Numerical Recipes", by W. Press, et al., pg 91
c/
c/ PARAMETERS
c/    xx: array of length n
c/    n : lenth of array
c/    x : value of x whose position we seek
c/
c/ RETURNS
c/    jlo: on output, x is between xx(jlo) and xx(jlo+1)
c/
c/ NOTE:
c/    This is a "hidden" routine, i.e., it does not appear in Beams.mod
c/
c///////////////////////////////////////////////////////////////////////

      subroutine hunt(xx, n, x, jlo)

      integer inc, jhi, jlo, jm, n
      real xx(n), x
      logical ascnd

      ascnd = xx(n).gt.xx(1)
      if (jlo.le.0.or.jlo.gt.n) then
        jlo = 0
        jhi = n + 1
        go to 3
      endif
      inc = 1
      if(x.ge.xx(jlo).eqv.ascnd) then    ! Hunt up
1       jhi = jlo + inc
        if (jhi.gt.n) then
          jhi = n + 1
        else if(x.ge.xx(jhi).eqv.ascnd) then
          jlo = jhi
          inc = inc + inc
          go to 1
        endif                   ! Done hunting, value bracketed
      else                      ! Hunt down
        jhi = jlo
2       jlo = jhi - inc
        if(jlo.lt.1) then
          jlo = 0
        else if (x.lt.xx(jlo).eqv.ascnd) then
          jhi = jlo
          inc = inc + inc
          go to 2
        endif                   ! Done hunting, value bracketed
      endif

c-----Begin final bisection phase:
3     if (jhi-jlo.eq.1) return
      jm = (jhi + jlo)/2
      if (x.gt.xx(jm).eqv.ascnd) then
        jlo = jm
      else
        jhi = jm
      endif
      go to 3 
      
      end

c///////////////////////////////////////////////////////////////////////
c/
c/ NAME 
c/   Beams_gaussWts
c/
c/ DESCRIPTION
c/    calculates Gaussian weights and abscissae for the integrations
c/    needed in the neutral beam calculations
c/
c/ PARAMETERS
c/    n:    number of nodes
c/ 
c/ RETURNS
c/    w:    weight factor
c/    s:    vector with the weight functions
c/
c///////////////////////////////////////////////////////////////////////

      subroutine gaussWts (n, w, sgauss)

c/    Local Variable Declarations:
c/    ---------------------------
      integer i, n
      real w, sgauss(n), pi
      
      data pi /3.14159265/
 
      w = pi/float(n)
      do i = 1, n 
         sgauss(i) = cos(pi*(2.0*float(i) - 1.0)/
     .             (2.0*float(n)))
      enddo
 
      return
      end

      subroutine calcBeams(nbeams, amb, zbeam, ebeam, pbeam, inbfus, 
     .   rtang, nbshape, bwidth, bheigh, nbptype, bgaussR, bgaussZ, 
     .   bzpos, pwrfrac, maxiter, nion, aion, zion, ne20, ni20, tekev, 
     .   tikev, zeff, r0, a, b0, volp, n, rnorm, vprime, dvol, darea, 
     .   kappa, dkappa, shafr, dshafr, hofr, shinethru, jnbTot, pnbe, 
     .   pnbi, beamDens, beamPress, beamFus, pbfuse, pbfusi, snBeamDD, 
     .   snBeamDT, nbcur, etanb, gammanb, pNBAbsorb, pNBLoss, nbcurTot, 
     .   etanbTot, beamBeta, pNBAbsorbTot, pNBLossTot, beamFusTot, 
     .   beamFusChTot, snDTTotal, snDDTotal, iflag)


c///////////////////////////////////////////////////////////////////////
c/
c/    This is the main calling routine of the Neutral Beam package.
c/    It calls various routines to calculate the most common NB 
c/    deposition, heating and fast ion quantities including NB current
c/    drive and beam-target fusion parameters. 
c/
c/    This package was originally developed for the SuperCode project 
c/    (~1992) by John Mandrekas. It has been modified by the author for 
c/    submission to the National Transport Code Collaboration (NTCC). 
c/    
c/    Latest release: 08/22/2000
c/
c/    Questions, comments and bug reports should be addressed to:
c/
c/                 John Mandrekas
c/                 Georgia Institute of Technology
c/                 Fusion Research Center
c/                 Atlanta, GA 30332-0225
c/                 Tel: (404) 894-7730
c/                 E-mail: john.mandrekas@me.gatech.edu
c/
c/    DESCRIPTION OF VARIABLES IN THE SUBROUTINE CALLING LIST
c/
c/    Neutral beam related input parameters:
c/    -------------------------------------
c/    Notice: We can have as many beamlines as desired, with the 
c/    following limitations:
c/
c/    1) The beam ion species should be the same for all beamlines
c/    2) If beam-target fusion calculations are desired, then the
c/       beam ions should be either Deuterium or He3. For NB deposition
c/       and current drive calculations, any H species is OK.
c/
c/    nbeams    : Number of beamlines
c/    amb       : Atomic weight of beam ions (1 for H, 2 for D, etc.)
c/    zbeam     : Atomic number of beam ions 
c/    ebeam(ib) : Beam energy of each beamline (keV)
c/    pbeam(ib) : Beam power of each beamline  (MW)
c/
c/    pwrfr(ie,ib) : The fraction of power in the energy component
c/                   ie (ie = 1,2,3 corresponding to full, half and 
c/                   1/3 energy components) for each beamline ib 
c/
c/    inbfus      : Flag for the beam-target fusion calculations:
c/                  0 - Do not calculate
c/                  1 - Calculate
c/    rtang(ib)   : Tangency radius of each beamline (m)
c/    nbshape(ib) : Flag determining the cross section shape of each 
c/                  beamline. Available options are 0 for circular
c/                  and 1 for rectangular.
c/    bwidth(ib)  : Width (or diameter for circular) of each beamline (m)
c/    bheigh(ib)  : Height of each beamline (m)
c/    nbptype(ib) : Flag for power distribution in the beam cross section.
c/                  0 : uniform distribution
c/                  1 : Gaussian (circular) or bi-Gaussian (rectangular)
c/                  p ~ exp(-(r/gaussR)**2) - circular
c/                  p ~ exp(-(R/gaussR)**2)*(exp(-((Z-bzpos)/gaussZ)**2 +
c/                                          exp(-((Z+bzpos)/gaussZ)**2))
c/
c/    bgaussR(ib) : Gaussian width (radial direction for circular beams,
c/                  horizontal direction for rectangular beams). (m)
c/    bgaussZ(ib) : Gaussian width in vertical direction for rectangular 
c/                  beams (m)
c/    bzpos(ib)   : Position of peak in Z direction for bi-Gaussian 
c/                  power distribution (rectangular shapes only) (m)
c/    
c/    maxiter     : Maximum number of iterations in the GETRHO routine
c/                  which finds the rho corresponding to a given R.
c/                  Recommended value: 2
c/
c/    Background Plasma Input Quantities:
c/    ----------------------------------
c/    nion        : Number of ion species (includes main ions and impurities)
c/    aion(j)     : Atomic Mass of j-th ion species (j = 1,nion)
c/    zion(j)     : Atomic Number of j-th ion species
c/    ne20(i)     : Electron density at grid point -i- (10^20 /m^3)
c/    ni20(i,j)   : Ion density at -i- for ion species -j- (10^20 /m^3)
c/    tekev(i)    : Electron temperature at -i- (keV)
c/    tikev(i)    : Ion temperature at -i- (keV)
c/    zeff(i)     : Plasma Zeff at grid point -i-
c/
c/    Geometry and MHD Input Variables:
c/    --------------------------------
c/    r0          : Major radius (m)
c/    a           : Minor radius (m)
c/    b0          : Toroidal magnetic field (T)
c/    volp        : Plasma volume (m^3)
c/    n           : Number of radial grid points
c/    rnorm(i)    : Normalized radial coordinate (0 at center, 1 at edge)
c/    vprime(i)   : dVol/dr (m^2)
c/    dvol(i)     : Volume of cell -i- (m^3)
c/    darea(i)    : Cross sectional area of cell (i) (m^2)
c/    kappa(i)    : Elongation at grid point i
c/    dkappa(i)   : d_kappa / drho at -i- (rho is normalized here)
c/    shafr(i)    : Shafranov shift (normalized to minor radius)
c/    dshafr(i)   : d_shift/d_rho (both shift and rho normalized)
c/
c/    Calculated (output) Variables:
c/    -----------------------------
c/    hofr(i,ie,ib) : Neutral beam deposition profile for beam ib, 
c/                    energy component ie, at grid point i. Notice that
c/                    the deposition profile is normalized to 1!
c/
c/    shinethru(ie,ib) : Beam shinethrough for beam ib and energy component
c/                       ie.
c/
c/    jnbTot(i)     : Total neutral beam driven current density from all
c/                    beam lines and energy groups at grid point i (A/m^2)
c/    pnbe(i)       : Beam heating power to electrons at i (MW/m^3)
c/    pnbi(i)       : Beam heating power to ions at i (MW/m^3)
c/    beamDens(i)   : Fast beam ion density at grid point i (/m^3)
c/    beamPress(i)  : Fast beam ion pressure at i (Pa)
c/    beamFus(i)    : Beam-target total fusion power density at grid
c/                    point i (this includes neutron AND charge particle
c/                    contributions) (MW/m^3). 
c/    pNBLoss(ib)   : Neutral beam power lost per beamline (MW). 
c/    pNBAbsorb(ib) : Neutral beam power absorbed per beamline (MW). 
c/    pbfuse(i)     : Beam-target fusion power to electrons (MW/m^3)
c/    pbfusi(i)     : Beam-target fusion power to ions (MW/m^3)
c/    snBeamDD(i)   : Volumetric DD neutron rate production (#n/s/m^3)
c/    snBeamDT(i)   : Volumetric DT neutron rate production (#n/s/m^3)
c/    nbur(ib)      : NB driven current from beam ib (A)
c/    etanb(ib)     : NB current drive efficiency for beam ib (A/W)
c/    gammanb(ib)   : NBCD figure of merit for beam ib  (10^20 A/W/m^2)
c/    pNBAbsorbTot  : Total NB power absorbed in the plasma. 
c/    pNBLossTot    : Total NB power lost.
c/    nbcurTot      : Total NB driven current (A). 
c/    etanbTot      : Total current drive efficiency (A/W). 
c/    beamBeta      : Total beta of the fast ions
c/    beamFusTot    : Total beam-target fusion power (MW). 
c/    beamFusChTot  : Total charged particle beam fusion power (MW).
c/    snDTTotal     : Total beam-target DT neutron rate production (#/s)
c/    snDDTotal     : Total beam-target DD neutron rate production (#/s)
c/
c/    iflag         : Error flag. If not equal to zero, then a problem
c/                    was encountered.
c/
c/    ADDITIONAL OUTPUT VARIABLES:
c/
c/    The above output variable list represents only a small selection of
c/    the various calculated quantities in the module. Some of the other
c/    calculated quantities that may be of interest are included below.
c/    If they are needed, then they should be placed in the calling 
c/    statement of this subroutine.
c/    
c/    beamFusElecTot : Electron beam-target fusion power (MW). 
c/    beamFusIonTot  : Ion beam-target fusion power (MW). 
c/
c/    pitchangl(i,ie,ib) : Cosine of the average fast ion pitch angle for
c/                         the ie energy component of beamline ib at grid
c/                         point i. 
c/
c/    jnbie(i,ie,ib)  : Neutral beam driven current density by the
c/                      ie component of beam ib at grid point i (A/m^2). 
c/    jnb(i,ib)       : Neutral beam driven current density due to
c/                      beamline ib at grid point i (A/m^2). 
c/    beamDDFus(i)    : Beam-target fusion power density from DD
c/                      reactions at grid point i (MW/m^3). 
c/    beamDTFus(i)    : Beam-target fusion power density  
c/                      from DT reactions (MW/m^3). 
c/    beamFusDTHe4(i) : Beam-target fusion power density to the
c/		        He4 particles of the DT reaction (MW/m^3). 
c/    beamFusDDHe3(i) : Beam-target fusion power density to the
c/                      He3 particles of the DD reaction (MW/m^3). 
c/    beamFusDDp(i)   : Beam-target fusion power density 
c/  		        in the protons of the DD reaction (MW/m^3).
c/    beamFusDDt(i)   : Beam-target fusion power density in the
c/ 		        tritons of the DD reaction (MW/m^3). 
c/
c/    About the radial grid:
c/    ---------------------
c/    The regular grid consists of n grid points (uniform or nonuniform)
c/    from the magnetic axis (rnorm(1) = 0) to the last closed flux surface
c/    (rnorm(n) = 1.0). All output profile quantities and input radial plasma
c/    profiles (ne, ni, Te, Ti, etc.) are supposed to be defined at these
c/    grid points. However, dvol, darea, and vprime are defined at the 
c/    boundaries of a cell centered around each grid point, which can
c/    be considered as a "half-grid", i.e. r(i+1/2) = 0.5*(r(i) + r(i+1)). 
c/    So, dvol(i) is the volume enclosed between r(i+1/2) and r(i-1/2).
c/    The calculations are carried out from i = 1, to i = n-1, so there is
c/    no need to define dvol(n) or darea(n). However, vprime(n) should be
c/    defined.
c/    
c/    Historical Note (J. Mandrekas, 08/23/00):
c/    ----------------------------------------
c/    This module was originally developed by the author for the SuperCode 
c/    (S.W. Haney, L.J. Perkins, J. Galambos and J. Mandrekas) a mixed
c/    C++/Fortran code running under a shell. In this code, variables were
c/    either Public or Private and were included in 'Module Descriptor Files'
c/    which were similar to Fortran Common Blocks. I have moved the private
c/    variables into the BeamsLoc.inc common block. Most of the 'public'
c/    variables are now included in the subroutine list, while a lot of 
c/    background plasma and geometry related variables are in the common
c/    block 'nbplasma.inc'. To avoid rewriting large parts of the code, 
c/    some global variables are copied to local versions which are then
c/    stored in one of the common blocks.

      implicit none
      
      include 'nbparams.inc' 
      include 'BeamsLoc.inc'
      include 'nbplasma.inc'
      include 'nbconsts.inc'
      
c/    Subroutine Variable Declarations:
c/    --------------------------------
      integer iflag, nbeams, inbfus, n, nion, maxiter
      integer nbshape(maxBeams), nbptype(maxBeams)

      real amb, zbeam, r0, a, b0, volp, nbcurTot, etanbTot, beamBeta,
     .     pNBAbsorbTot, pNBLossTot, beamFusTot, beamFusChTot,
     .     snDDTotal, snDTTotal

      real ebeam(maxBeams), pbeam(maxBeams), rtang(maxBeams), 
     .     bwidth(maxBeams), bheigh(maxBeams), bgaussR(maxBeams), 
     .     bgaussZ(maxBeams), bzpos(maxBeams), pwrfrac(3, maxBeams), 
     .     aion(maxIons), zion(maxIons), ne20(mxrho), 
     .     ni20(mxrho,maxIons), tekev(mxrho), tikev(mxrho), zeff(mxrho),
     .     rnorm(mxrho), vprime(mxrho), dvol(mxrho), darea(mxrho),
     .     kappa(mxrho), dkappa(mxrho), shafr(mxrho), dshafr(mxrho), 
     .     hofr(mxrho,3,maxBeams), shinethru(3,maxBeams), jnbTot(mxrho),
     .     pnbe(mxrho), pnbi(mxrho), beamDens(mxrho), beamPress(mxrho),
     .     beamFus(mxrho), pbfuse(mxrho), pbfusi(mxrho),snBeamDD(mxrho),
     .     snBeamDT(mxrho), nbcur(maxBeams), etanb(maxBeams), 
     .     gammanb(maxBeams), pNBAbsorb(maxBeams), pNBLoss(maxBeams)

c/    Local Variable Declarations:
c/    ---------------------------


c/    Variables in the FASTIONS subroutine list, but not exported by this
c/    routine:

      real jnbie(mxrho,3,maxBeams), jnb(mxrho,maxBeams),
     .     beamDDFus(mxrho), beamDTFus(mxrho), beamFusDTHe4(mxrho), 
     .     beamFusDDHe3(mxrho), beamFusDDp(mxrho), beamFusDDt(mxrho)

c/    Other local variables:

      real beamFusElecTot, beamFusIonTot
      real beamFusIon(mxrho), beamFusElec(mxrho)

      real eDDHe3, eDTHe4, eDDp, eDDt, massHe3, massHe4, massp, masst,
     .   elecVolAvg, sumjnb, sumpnbi, sumpnbe

      real sdot
      integer i, j, ib, ie, isp, nrhom1

      data eDDHe3/820.00/, eDDp/3020.0/, eDDt/1010.0/, eDTHe4/3500.00/,
     .     massHe3/3.0/, massHe4/4.0/, massp/1.0/, masst/3.0/

      iflag = 0

c/    Check dimensions and return with error message if not right:

      if (nbeams.GT.maxBeams) then
	 iflag = 1
	 write (6,*) 'ERROR: Maximum beams dimension exceeded'
	 return
      endif

      if (nion.GT.maxIons) then
	 iflag = 2
	 write (6,*) 'ERROR: Maximum number of ions dimension exceeded'
	 return
      endif

      if (n.GT.mxrho) then
	 iflag = 3
	 write (6,*) 'ERROR: Radial grid points dimension exceeded'
	 return
      endif

c/    Assign variables in the subroutine statement to local variables:
c/    ---------------------------------------------------------------
      ab = amb
      maxit = maxiter

      do i = 1, nbeams
	 do ie = 1, 3
	    fbpwr(ie,i) = pwrfrac(ie,i)
         enddo
      enddo	

      nrho = n
      nrhom1 = nrho - 1
      rmajor = r0
      rminor = a
      volume = volp
      nions = nion
      
      do j = 1, nions
	 atw(j) = aion(j)
	 znum(j) = zion(j)
      enddo

c/    Notice: Below we use the BLAS routine scopy which copies one
c/    vector into another. If BLAS is not available (unlikely) then
c/    this part can be replaced by a simple do loop.
c/    
      call scopy (n, rnorm, 1, rho, 1) 
      call scopy (n, vprime, 1, vpr, 1) 
      call scopy (n, dvol, 1, dv, 1) 
      call scopy (n, kappa, 1, elong, 1) 
      call scopy (n, dkappa, 1, elong_rho, 1) 
      call scopy (n, shafr, 1, shift, 1) 
      call scopy (n, dshafr, 1, shift_rho, 1) 
      call scopy (n, ne20, 1, elecDensity, 1)
      call scopy (n, tekev, 1, elecTemp, 1)
      call scopy (n, tikev, 1, ionTemp, 1)
      call scopy (n, zeff, 1, zef, 1)
      do j = 1, nions
	 call scopy(n, ni20(1,j), 1, dni(1,j), 1)
      enddo

c/    The following part of the code is needed to separate the ion 
c/    species that are included in Boley's beam stopping cross section
c/    routine from those that are not and will be treated using 
c/    Olson's formulation:
      
      do isp = 1, nions
	 inonb = 0
	 if(atw(isp).EQ.1.0.AND.znum(isp).EQ.1.) then
	    ihydr = isp
         else if (atw(isp).EQ.2.0.AND.znum(isp).EQ.1.) then
	    ideut = isp
         else if (atw(isp).EQ.3.0.AND.znum(isp).EQ.1.) then
	    itrit = isp
         else if (atw(isp).EQ.3.0.AND.znum(isp).EQ.2.) then
	    ihe3 = isp
	    inonb = inonb + 1
	    nonbindx(inonb) = isp
         else if (atw(isp).EQ.4.0.AND.znum(isp).EQ.2.) then
	    ihe4 = isp
         else if (atw(isp).EQ.12.0) then
	    icarb = isp
         else if (atw(isp).EQ.16.0) then
	    ioxy = isp
         else if (atw(isp).EQ.56.0) then
	    iFe = isp
         else
	    inonb = inonb + 1
	    nonbindx(inonb) = isp
         endif
      enddo
      
c/    Calculate fast ion deposition:
c/    -----------------------------
      call hofrho (nbeams, ebeam, pbeam, rtang, nbshape, bwidth, 
     .   bheigh, nbptype, bgaussR, bgaussZ, bzpos, hofr, shinethru,
     .   pNBAbsorb, pNBLoss, pNBAbsorbTot, pNBLossTot)


c/    Calculate fast ion related parameters:
c/    -------------------------------------
      call fastIons (nbeams, amb, zbeam, ebeam, pbeam, inbfus,
     .   hofr, shinethru, jnbie, jnb, jnbTot, beamDens, beamPress,
     .   beamFus, beamDTFus, beamDDFus, beamFusDTHe4, beamFusDDHe3,
     .   beamFusDDp, beamFusDDt, snBeamDT, snBeamDD)

c/    Calculate total beam heating power density (in MW/m^3):
c/    (summed over all beams and energy components)
c/    Recall that now hofr is normalized, so we must multiply
c/    by 1.0 - shinethru(ie,ib):
c/    
      do i = 1, nrho
         sumpnbi = 0.0
         sumpnbe = 0.0
         do ib = 1, nbeams
            do ie = 1, 3
              sumpnbi = sumpnbi + pbeam(ib)*fbpwr(ie,ib)*
     .         (1.0 - shinethru(ie,ib)) * hofr(i,ie,ib)*fNBion(i,ie,ib)
              sumpnbe = sumpnbe + pbeam(ib)*fbpwr(ie,ib)*
     .         (1.0 - shinethru(ie,ib)) * hofr(i,ie,ib)*fNBelec(i,ie,ib)
            enddo
         enddo
         pnbi(i) = sumpnbi/volume
         pnbe(i) = sumpnbe/volume
      enddo

c/    Total driven current per beamline (A) and current drive
c/    efficiencies (summed over energy components);

      elecVolAvg = sdot(nrhom1,elecDensity,1,dvol,1) / volume 
      
      nbcurTot = 0.0
      do ib = 1, nbeams
         sumjnb = 0.0 
         do i = 1, nrhom1
            sumjnb = sumjnb + jnb(i,ib) * darea(i)
         enddo
         nbcur(ib) = sumjnb
         if (pNBAbsorb(ib).ne.0.0) 
     .      etanb(ib) = 1.0e-06*nbcur(ib) / pNBAbsorb(ib)
         gammanb(ib) =  elecVolAvg*rmajor*etanb(ib)
         nbcurTot = nbcurTot + nbcur(ib)
      enddo

      if (pNBAbsorbTot.ne.0.0) then
         etanbTot = 1.0e-06*nbcurTot / pNBAbsorbTot
      endif

c/    Calculate the beam beta:
c/    -----------------------
      beamBeta = sdot(nrhom1, beamPress, 1,dvol, 1)
      beamBeta = 2.0*muZero*beamBeta / (volume*b0**2)

c/    Calculate beam-target related quantities (if inbfus=1):
c/    ----------------------------------------------------
      beamFusTot = 0.0
      beamFusElecTot = 0.0
      beamFusIonTot = 0.0
      beamFusChTot = 0.0
      snDDTotal = 0.0
      snDTTotal = 0.0
      
      if (inbfus.ne.0) then
      
c/    Calculate division of power to electrons and ions for charged
c/    particle products of the beam-plasma interactions:

         call eiSplit (eDDHe3, massHe3, fDDHe3ion, fDDHe3elec)
         call eiSplit (eDDp, massp, fDDpion, fDDpelec)
         call eiSplit (eDDt, masst, fDDtion,fDDtelec)
         call eiSplit (eDTHe4, massHe4, fDTHe4ion, fDTHe4elec)
         
         do i = 1, nrho
            beamFusIon(i) = beamFusDDHe3(i) * fDDHe3ion(i) +
     .                      beamFusDDp(i) * fDDpion(i) +
     .                      beamFusDDt(i) * fDDtion(i) +
     .                      beamFusDTHe4(i) * fDTHe4ion(i)
            beamFusElec(i) = beamFusDDHe3(i) * fDDHe3elec(i) +
     .                       beamFusDDp(i) * fDDpelec(i) +
     .                       beamFusDDt(i) * fDDtelec(i) +
     .                       beamFusDTHe4(i) * fDTHe4elec(i)
         enddo

c/   Calculate totals of selected quantities:
         
         beamFusTot = sdot(nrhom1,beamFus,1,dvol,1)
         beamFusElecTot = sdot(nrhom1,beamFusElec,1,dvol,1)
         beamFusIonTot = sdot(nrhom1,beamFusIon,1,dvol,1)
         beamFusChTot = beamFusElecTot + beamFusIonTot
         snDDTotal = sdot(nrhom1,snBeamDD,1,dvol,1)
         snDTTotal = sdot(nrhom1,snBeamDT,1,dvol,1)
         
      endif

      return
      end

C  Purpose:    Sum the values of a single precision vector.
C
C  Usage:      SSUM(N, SX, INCX)
C
C  Arguments:
C     N      - Length of vectors X.  (Input)
C     SX     - Real vector of length N*INCX.  (Input)
C     INCX   - Displacement between elements of SX.  (Input)
C              X(I) is defined to be SX(1+(I-1)*INCX). INCX must be
C              greater than 0.
C     SSUM   - Single precision sum from I=1 to N of X(I).  (Output)
C              X(I) refers to a specific element of SX.
C
C-----------------------------------------------------------------------
C
      REAL FUNCTION SSUM (N, SX, INCX)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER    N, INCX
      REAL       SX(*)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER    I, M, MP1, NINCX
C                                  SPECIFICATIONS FOR SPECIAL CASES
C     INTRINSIC  MOD
      INTRINSIC  MOD
      INTEGER    MOD
C
      SSUM = 0.0E0
      IF (N .GT. 0) THEN
         IF (INCX .NE. 1) THEN
C                                  CODE FOR INCREMENT NOT EQUAL TO 1
            NINCX = N*INCX
            DO 10  I=1, NINCX, INCX
               SSUM = SSUM + SX(I)
   10       CONTINUE
         ELSE
C                                  CODE FOR INCREMENT EQUAL TO 1
            M = MOD(N,6)
C                                  CLEAN-UP LOOP
            DO 30  I=1, M
               SSUM = SSUM + SX(I)
   30       CONTINUE
            MP1 = M + 1
            DO 40  I=MP1, N, 6
               SSUM = SSUM + SX(I) + SX(I+1) + SX(I+2) + SX(I+3) +
     &                SX(I+4) + SX(I+5)
   40       CONTINUE
         END IF
      END IF
      RETURN
      END

c/    This program is a driver to test the NB module nbeams. It is not
c/    part of the nbeams package. Its purpose is to create a background
c/    plasma (geometry, MHD and plasma profiles) and then call the NB 
c/    routines to calculate various neutral beam heating and current drive 
c/    parameters.
c/
c/    The program reads the input file 'inbeams.dat' which contains a 
c/    namelist with various input variables, calls the main routine of
c/    the NB module (calcBeams) and prints out some information to the 
c/    file 'outbeams.dat'
c/
c/    Written by John Mandrekas, GIT, for the NTCC 08/29/00
c/
c/    Description of some of the input variables in the namelist
c/    (Only the local variables are included here. For a description
c/    of the variables in the calcBeams list see the extensive comments
c/    in the beginning of the calcbeams.f routine)
c/
c/    e0         - elongation at center
c/    ea         - elongation at edge
c/    shft0      - shift of magnetic axis (normalized to minor radius)  
c/    teavg      - Density-weighted volume average electron temperature (keV)
c/    tea        - Electron temperature at the edge (separatrix) (keV)
c/    tiavg      - Density-weighted volume average ion temperature (keV)
c/    tia        - Ion temperature at the edge (separatrix) (keV)
c/    alfat      - Temperature profile exponent
c/    denav      - Average electron density (10^20 /m^3)
c/    edgavr     - edge-to-average ratio, ne(a)/<ne>
c/    alfan      - Density profile exponent
c/    fion       - Concentration of each ion species (ni/ne)
         
c/
      implicit none
      include 'nbparams.inc'

c/    Variables in the calcBeams variable list:
c/    ----------------------------------------
      integer iflag, ie, ib, nbeams, inbfus, n, nion, maxiter
      integer nbshape(maxBeams), nbptype(maxBeams)

      real amb, zbeam, r0, a, b0, volp, nbcurTot, etanbTot, beamBeta,
     .     pNBAbsorbTot, pNBLossTot, beamFusTot, beamFusChTot,
     .     snDDTotal, snDTTotal

      real ebeam(maxBeams), pbeam(maxBeams), rtang(maxBeams), 
     .     bwidth(maxBeams), bheigh(maxBeams), bgaussR(maxBeams), 
     .     bgaussZ(maxBeams), bzpos(maxBeams), pwrfrac(3, maxBeams), 
     .     aion(maxIons), zion(maxIons), ne20(mxrho), 
     .     ni20(mxrho,maxIons), tekev(mxrho), tikev(mxrho), zeff(mxrho),
     .     rnorm(mxrho), vprime(mxrho), dvol(mxrho), darea(mxrho),
     .     kappa(mxrho), dkappa(mxrho), shafr(mxrho), dshafr(mxrho), 
     .     hofr(mxrho,3,maxBeams), shinethru(3,maxBeams), jnbTot(mxrho),
     .     pnbe(mxrho), pnbi(mxrho), beamDens(mxrho), beamPress(mxrho),
     .     pbfuse(mxrho), pbfusi(mxrho), snBeamDD(mxrho),beamFus(mxrho),
     .     snBeamDT(mxrho), nbcur(maxBeams), etanb(maxBeams), 
     .     gammanb(maxBeams), pNBAbsorb(maxBeams), pNBLoss(maxBeams)

c/    Local variables:
      
      integer i, j, ip1, nm1, nbinp, nbout
      real teavg, tiavg, tea, tia, denav, edgavr, alfan, alfat, e0, 
     .   ea, shft0, dlr, tt, pi, ti0, te0, den0, L_tor, sumzef,
     .   rn2, ssum

      real fion(maxIons), r(mxrho), rmid(mxrho)

      namelist /nbin/ nbeams, inbfus, n, nion, maxiter, nbshape, 
     .    nbptype, amb, zbeam, ebeam, pbeam, rtang, bwidth, bheigh,
     .    bgaussR, bgaussZ, bzpos, pwrfrac, aion, zion, r0, a, b0,
     .    e0, ea, shft0, teavg, tiavg, tea, tia, alfat, denav, edgavr, 
     .    alfan, fion

      pi = acos(-1.0)

c/    Assign I/O unit numbers:
c/    -----------------------
      nbinp = 10
      nbout = 20

c/    Open files:
c/    ----------
      open (nbinp, file = 'inbeams.dat', status = 'old')
      open (nbout, file = 'outbeams.dat', status = 'unknown')
      
      read (nbinp, nbin)
      
c/    BACKGROUND PLASMA:

c/    Grid and other geometric quantities:
c/    -----------------------------------
      nm1 = n - 1
      dlr = a / float(nm1)
      r(1) = 0.0
      do i = 2, n
          r(i) = r(i-1) + dlr
      enddo

c/    Interface grid:
c/    --------------
c/    Notice that i+1/2 corresponds to i+1 in the interface grid!
      rmid(1) = 0.0
      do i = 2, n
        rmid(i) = 0.5 * (r(i-1) + r(i))
      enddo

c/    Neutral Beam normalized grid:

      do i = 1, n
         rnorm(i) = r(i) / r(n)
         rn2 = rnorm(i)**2
         tt = 1.0 - rn2
         kappa(i)  = e0 + (ea - e0)*rn2                                         
         dkappa(i) = 2.0*(ea - e0) * rnorm(i)                                
         shafr(i)  = shft0 * tt
         dshafr(i) = -2.0 * shft0 * rnorm(i)
      enddo
         
c/    Cylindrical limit of  important metric  quantities:
c/    --------------------------------------------------

      L_tor = 2.0 * pi * r0
      vprime(1) = 0.0
      do i = 1, nm1
	ip1 = i + 1
        dvol(i) = L_tor * pi * kappa(i) * (rmid(ip1)**2 - rmid(i)**2)
	vprime(ip1) = L_tor * 2.0 * pi * kappa(i) * rmid(ip1)
	darea(i) = dvol(i) / L_tor 
      enddo
      
      dvol(n) = 0.0
      darea(n) = 0.0

c/    Plasma volumes:
c/    --------------
      volp = ssum(nm1, dvol, 1)
      
c/    Parabolic-like plasma profiles:
c/    ------------------------------
      te0 = ((1.0 + alfat+alfan) / (1.0 + alfan - alfan*alfat*edgavr /
     .   (1.0 + alfat))) * teavg
      ti0 = te0 * tiavg / teavg
      den0 = (1.0 + alfan - alfan*edgavr) * denav

      do  i = 1, n
        tt = 1.0 - (r(i) / a)**2
        tekev(i) = (te0 - tea) * tt**alfat + tea
        tikev(i) = (ti0 - tia) * tt**alfat + tia
        ne20(i) = (den0 - edgavr*denav) * tt**alfan + 
     .     edgavr*denav
	do j = 1, nion
	   ni20(i,j) = fion(j) * ne20(i)
	enddo
      enddo

c/    Calculation of the plasma Zeff:
c/    ------------------------------
      
      do i = 1, n
         sumzef = 0.0
         do j = 1, nion
            sumzef = sumzef + ni20(i,j) * zion(j)**2 / ne20(i)
         enddo
         zeff(i) = sumzef
      enddo

c/    Call the beams package:

      call calcBeams(nbeams, amb, zbeam, ebeam, pbeam, inbfus,      
     .   rtang, nbshape, bwidth, bheigh, nbptype, bgaussR, bgaussZ,       
     .   bzpos, pwrfrac, maxiter, nion, aion, zion, ne20, ni20, tekev,    
     .   tikev, zeff, r0, a, b0, volp, n, rnorm, vprime, dvol, darea,     
     .   kappa, dkappa, shafr, dshafr, hofr, shinethru, jnbTot, pnbe,     
     .   pnbi, beamDens, beamPress, beamFus, pbfuse, pbfusi, snBeamDD,    
     .   snBeamDT, nbcur, etanb, gammanb, pNBAbsorb, pNBLoss, nbcurTot,   
     .   etanbTot, beamBeta, pNBAbsorbTot, pNBLossTot, beamFusTot,        
     .   beamFusChTot, snDTTotal, snDDTotal, iflag)                       
                                                                          

c/    Write output quantities to file nbout:

 
c/    Global parameters
c/    -----------------
      write (nbout, 2000)
      write (nbout, 2100)
      write (nbout, 2200) pNBAbsorbTot, pNBLossTot, nbcurTot,
     .   etanbTot, beamBeta
      write (nbout, '(1x)')
      
      write (nbout, 2300)
      write (nbout, 2400)
      write (nbout, 2410) (pNBAbsorb(ib), ib = 1, nbeams)
      write (nbout, 2415) (pNBLoss(ib), ib = 1, nbeams)
      write (nbout, 2420) (nbcur(ib), ib = 1, nbeams)
      write (nbout, 2430) (etanb(ib), ib = 1, nbeams)
      write (nbout, 2440) (gammanb(ib), ib = 1, nbeams)
      write (nbout, '(1x)')
      write (nbout, 2450)
      write (nbout, 2460) (shinethru(1,ib), ib = 1, nbeams)
      write (nbout, 2470) (shinethru(2,ib), ib = 1, nbeams)
      write (nbout, 2480) (shinethru(3,ib), ib = 1, nbeams)
      write (nbout, '(1x)')
      
      if (inbfus.NE.0) then
         write (nbout, 2500)
         write (nbout, 2600) beamFusTot, beamFusChTot, snDTTotal, 
     .      snDDTotal
      endif
 
      write (nbout, '(1x)')

c/    Write the deposition profile for each beamline and energy group:
c/    ---------------------------------------------------------------
      write (nbout, *) 'Neutral Beam Deposition Profiles'
      write (nbout, *) '--------------------------------'
      do ib = 1, nbeams
         write (nbout, 1000) ib
         do i = 1, n
            write (nbout,1100) rnorm(i), (hofr(i,ie,ib),ie=1,3)
         enddo
         write (nbout, '(1x)')
      enddo

c/    Write heating and current drive profile information:
c/    ----------------------------------------------------
      write (nbout, 3000)
      do i = 1, n
         write (nbout, 3100) rnorm(i), jnbTot(i), pnbe(i), pnbi(i), 
     .	    beamDens(i), beamPress(i), beamFus(i)
      enddo
 
 
 1000 format (1x, 'Beam ', i2/
     .   5x, 'rho', 6x, 'hofr_1', 7x, 'hofr_2', 7x, 'hofr_3')
 1100 format (1x, f8.5, 3(1x,e12.5))
 
 2000 format (1x, 'Global NB Heating and Current Drive Parameters',/
     .        1x, '----------------------------------------------')
 2100 format (1x, 'TOTALS:')
 2200 format (1x, 'Total Absorbed Power      = ', f9.4, ' MW'/
     .        1x, 'Total Lost Power          = ', f9.4, ' MW'/
     .        1x, 'Total NB Driven Current   = ', e12.5,' A'/
     .        1x, 'Total NBCD Efficiency     = ', e12.5,' A/W'/
     .        1x, 'Total Beam Beta           = ', e12.5)
     
 2300 format (1x, 'Information per Beamline and Energy Group:'/
     .        1x, '-----------------------------------------')
 2400 format (23x,'Beam 1', 10x, 'Beam 2', 10x, 'Beam 3'/
     .        23x,'------', 10x, '------', 10x, '------')
 2410 format (1x, 'Absorbed Power   ', 1x, e12.5, 2(4x, e12.5))
 2415 format (1x, 'Lost Power       ', 1x, e12.5, 2(4x, e12.5))
 2420 format (1x, 'NB driven current', 1x, e12.5, 2(4x, e12.5))
 2430 format (1x, 'NBCD efficiency  ', 1x, e12.5, 2(4x, e12.5))
 2440 format (1x, 'NBCD gamma       ', 1x, e12.5, 2(4x, e12.5))
 2450 format (1x, 'Beam Shinethrough')
 2460 format (1x, '   energy group 1', 1x, e12.5, 2(4x, e12.5))
 2470 format (1x, '   energy group 2', 1x, e12.5, 2(4x, e12.5))
 2480 format (1x, '   energy group 3', 1x, e12.5, 2(4x, e12.5))
 
 2500 format (1x, 'Beam-Target Parameters'/
     .        1x, '----------------------')
 2600 format (1x, 'Total Beam-Target Fusion Power   = ', e12.5, ' MW'/
     .        1x, 'Total Power to Charged Particles = ', e12.5, ' MW'/
     .        1x, 'Total DT Neutron Rate            = ', e12.5, ' n/s'/
     .        1x, 'Total DD Neutron Rate            = ', e12.5, ' n/s')
     
 3000 format (3x, 'rho', 5x, 'jnbtot', 6x, 'pNBe', 8x, 'pNBi', 8x,
     .   'nbfast', 6x, 'pressb', 6x, 'pfusb')
 3100 format (1x, f6.4, 6(1x, e11.4))          
     
      stop 
      end

c/////////////////////////////////////////////////////////////////////////
c/
c/ NAME 
c/    Beams_zinteg
c/
c/ DESCRIPTION
c/    This subroutine calculates the Z-part of the 2D integral
c/    for the calculation of the beam deposition profile.
c/    Written by John Mandrekas, GIT, for the SuperCode
c/    Revisions:
c/    04-14-92, John Mandrekas:
c/       Updated to handle three beams with three energy components 
c/    10-25-91, John Mandrekas:
c/       Original release
c/
c/ PARAMETERS
c/    None
c/
c/ RETURNS
c/    Nothing
c/
c/////////////////////////////////////////////////////////////////////////

      subroutine zinteg
      
      implicit none
      include 'nbparams.inc'
      include 'BeamsLoc.inc'
      include 'nbconsts.inc'
      

c/    Local variable declarations:
c/    ---------------------------
      integer ie, iz
      real  dterm, eterm, el2, el3, sumz1, sumz2, sumz3, zb2, zu, 
     .      zterm1, zterm, ztest, resltz, sumzksi1, sumzksi2, sumzksi3

c/    Limiting case for rho -> 0.0:

      if (rhoi.le.0.0) then
         zb = 0.0
         call rinteg
         zterm  = 0.5*pi*elong0
         do ie = 1, 3
            alongz(ie) = alongr(ie)*zterm
            avksi(ie)  = alongksi(ie)*zterm
         enddo
         return
      endif

c/    Integration limits in the z direction:

      ztest = rhoi*elongr
      if (shape.eq.0) zu = min (ztest, rbeam)
      if (shape.eq.1) zu = min (ztest, 0.5*height)
      
      dterm = dshft/rhoi
      eterm = delong/rhoi
      el2   = elongr**2
      el3   = elongr**3
      
c/    Start integration:      

      sumz1 = 0.0
      sumz2 = 0.0
      sumz3 = 0.0
      sumzksi1 = 0.0
      sumzksi2 = 0.0
      sumzksi3 = 0.0
      do iz  = 1, nz
         zb  = 0.5*zu*(1.0 + sz(iz))
         zb2 = zb**2
         call rinteg
         zterm1 = (1.0 + eterm*zb2/el3)/
     .           Sqrt(rhoi**2 - zb2/el2) + sgn*dterm
         zterm = zterm1*Sqrt(1.0 - sz(iz)**2)
         sumz1 = sumz1 + alongr(1)*zterm
         sumz2 = sumz2 + alongr(2)*zterm
         sumz3 = sumz3 + alongr(3)*zterm
         sumzksi1 = sumzksi1 + alongksi(1)*zterm
         sumzksi2 = sumzksi2 + alongksi(2)*zterm
         sumzksi3 = sumzksi3 + alongksi(3)*zterm
      enddo
     
      resltz = 0.5*zu*wz
      alongz(1) = resltz*sumz1
      alongz(2) = resltz*sumz2
      alongz(3) = resltz*sumz3
      avksi(1)  = resltz*sumzksi1
      avksi(2)  = resltz*sumzksi2
      avksi(3)  = resltz*sumzksi3
      
      return
      end

c///////////////////////////////////////////////////////////////////////
c/
c/ NAME
c/    Beams_getrho
c/
c/ DESCRIPTION
c/   This subroutine finds the value of rho (rhotest) for given
c/   R (rprime). It is based on an iteration scheme, using the
c/   routine HUNT.FOR.
c/   Written by John Mandrekas, GIT, 02-03-92, for the SuperCode
c/
c/ PARAMETERS
c/    rprime  :  R for which we seek rho
c/
c/ RETURNS
c/    rhotest : The calculated value of rho (normalized)
c/    jlo     : rhotest is between rho(jlo) and rho(jlo+1)
c/
c///////////////////////////////////////////////////////////////////////
    

      subroutine getrho (rprime,  rhotest, jlo)
      
      implicit none
      include 'nbparams.inc'
      include 'nbplasma.inc'
      include 'BeamsLoc.inc'

      integer i, jtest, jlo
      real rprime, rhotest


c/    nstart  : if nstart = 0, use the outer flux surface
c/              for a first guess. Otherwise, use the previous
c/              value of jtest (defined in subroutine rinteg).

      if (nstart.eq.0) then
         jtest = nrho
         nstart = 1
	 jlo = 0.0
      endif

      do i = 1, maxit
         rhotest = Sqrt((rprime - rmajor - 
     .     rminor*shift(jtest))**2 + (zb/elong(jtest))**2)/rminor
         call hunt (rho, nrho, rhotest, jlo)
	 if (jlo.le.0) jlo = 1
	 if (jlo.ge.nrho) jlo = nrho -1
         jtest = jlo + 1
      enddo

      return
      end
    

      subroutine fastIons (nbeams, amb, zbeam, ebeam, pbeam, inbfus, 
     .   hofr, shinethru, jnbie, jnb, jnbTot, beamDens, beamPress, 
     .   beamFus, beamDTFus, beamDDFus, beamFusDTHe4, beamFusDDHe3, 
     .   beamFusDDp, beamFusDDt, snBeamDT, snBeamDD)

c///////////////////////////////////////////////////////////////////////
c/
c/ NAME
c/    fastIons
c/
c/ DESCRIPTION
c/
c/    This subroutine calculates the current density driven by the
c/    neutral beams as a function of the flux surface label -rho-
c/    taking into account the  electron return current and the
c/    trapped electron correction, based on the uniform field solution
c/    of the Fokker-Planck equation for the fast ions.
c/    Written for the SUPERCODE by John Mandrekas, GIT
c/    Revisions:
c/    08-16-00, John Mandrekas
c/       Removed obsolete variables (deutPresent, etc.)
c/    06-05-92, John Mandrekas
c/       Updated it, to work with normalized deposition profiles.
c/    05-29-92, John Mandrekas
c/       Changed name to fastIons, to better reflect what the routine
c/       does.
c/    05-29-92, John Mandrekas
c/       Modified to calculate division of power between electrons and
c/       ions for the two-temperature implementation. Also, more
c/       resolution in the beam-target fusion reactions.
c/    04-15-92, John Mandrekas
c/       Modified to handle beams with three energy components.
c/       Changed definition of epsilon, to include shift.
c/    01-08-92, John Mandrekas
c/       Modified to calculate beam-target reaction rates and fast
c/       beta. 
c/    10-29-91, Original Release
c/
c/    References:
c/    ----------
c/    For the fast ion distribution function:
c/    J.D. Gaffey, J. Plasma Physics 16, 149 (1976)
c/    For the fit to the trapped electron correction:
c/    D.R. Mikkelsen, C.E. Singer, Nuclear Technol./Fusion 4, 237 (1983)
c/
c/    Calculated quantities:
c/    ---------------------
c/    jnb(i,ie,ib) : neutral beam driven current density from the 
c/                   ie component of the ib beam at grid point i (A/m^2)
c/    jnb(i,ib)    : neutral beam driven current density from all energy
c/                   components of beam ib at i (A/m^2)
c/    jnbTot(i)    : total neutral beam driven current density at i
c/                   (summed over all beamlines and energy groups) (A/m^2)
c/    beamFus(i)   : beam-target fusion power density (MW/m^3)
c/                   (this includes charged particles AND neutrons)
c/                   from all possible reactions and all beamlines and
c/                   energy groups.
c/    beamDTFus(i) : beam-target fusion power density from DT beam-target
c/                   interactions (MW/m^3)
c/    beamDDFus(i) : beam-target fusion power density from DD beam-target
c/                   interactions (MW/m^3)
c/
c/    beamFusDTHe4(i) : charged particle (He4) beam-target fusion power
c/                      density at i (MW/m^3)
c/    beamFusDDHe3(i) : charged particle (He3) beam-target fusion power
c/                      density at i  (MW/m^3)
c/    beamFusDDp(i)   : charged particle (p) beam-target fusion power
c/                      density at i (MW/m^3)
c/    beamFusDDt(i)   : charged particle (t) beam-target fusion power
c/                      density at i (MW/m^3)
c/    beamPress(i)    : fast ion pressure from the beam ions (Pa)
c/    snBeamDD(i)     : rate of production of DD neutrons (#/s/m^3)
c/    snBeamDT(i)     : rate of production of DT neutrons (#/s/m^3)
c/    beamDens(i)     : fast ion density (#/m^3)
c/
c///////////////////////////////////////////////////////////////////////

     
      implicit none
      
      include 'nbparams.inc'
      include 'BeamsLoc.inc'
      include 'nbplasma.inc'
      include 'nbconsts.inc'

      integer nbeams, inbfus
      real amb, zbeam
      real ebeam(maxBeams), pbeam(maxBeams)
      real hofr(mxrho,3,maxBeams), jnbie(mxrho,3,maxBeams), 
     .     jnb(mxrho,maxBeams), shinethru(3,maxBeams), jnbTot(mxrho),
     .     beamDens(mxrho), beamPress(mxrho), beamFus(mxrho), 
     .     beamDDFus(mxrho), beamDTFus(mxrho), beamFusDTHe4(mxrho), 
     .     beamFusDDHe3(mxrho), beamFusDDp(mxrho), beamFusDDt(mxrho), 
     .     snBeamDD(mxrho), snBeamDT(mxrho) 
     
c/    Local variable declarations:
c/    ---------------------------
      real srcfast(mxrho,3,maxBeams), bmcur(3,maxBeams), 
     .     vbeam(3,maxBeams)
     
      real ami, bcoef, capke, cloge, clogi, comfact, dne20, energy,
     .     ecrit, eddn, eddp, edhe3, edtn, epsilon, factor,
     .     eddnhe3, eddpp, eddpt, edtnhe4,
     .     fb, frate, jfast, rcoef, reslt, rint, rrddn, rrddp,
     .     rrdhe3, rrdt, root3, sumbrack, sumhat, tauf, taus, term,
     .     sumjnbib, sumsDDib, sumsDTib, sumFusib, sumdnbib, sumPreib,
     .     sumDDFusib, sumDTFusib, sumFusDTHe4, sumFusDDHe3, sumFusDDp,
     .     sumFusDDt, sumjnbie, term1, term2, trapfact, xcr, yc, zbr,
     .     zhat, zte, zti, zz
      integer i, ie, isp, nfrst, nrhom1, jhy, jdeut, jtrit, jhe3, jhe4,
     .        ib, ibion, ireact
      external fb, frate
      common/intg/yc, zhat
      common/sigma/ecrit, comfact, ireact
      save nfrst, jhy, jdeut, jtrit, jhe3, jhe4, ibion

      data nfrst/0/, jhy/0/, jdeut/0/, jtrit/0/, jhe3/0/, jhe4/0/,
     .     ibion/0/
     
c/    Fusion reaction energies in MeV:

      data eddn/3.27/, eddp/4.03/, edhe3/18.3/, edtn/17.6/, 
     .   eddnhe3/0.82/, eddpp/3.02/, eddpt/1.01/, edtnhe4/3.50/

c/    Identify ion species for the fusion reactivity calculations:
c/    Current formulation allows injection of D or He3 beams.
c/    However, the beam species should also be a part of the plasma
c/    ion population:

      if (nfrst.eq.0.and.inbfus.eq.1) then
	 if (ideut.ne.0) jdeut = ideut
	 if (itrit.ne.0) jtrit = itrit
	 if (ihe3.ne.0) jhe3  = ihe3
	 if (ihe4.ne.0) jhe4  = ihe4
         if (amb.eq.2.0.and.zbeam.eq.1.0) ibion = jdeut
         if (amb.eq.3.0.and.zbeam.eq.2.0) ibion = jhe3
         if (ibion.eq.0) then ! cancel fusion calculations
            inbfus = 0
         endif
         nfrst = 1
      endif

      root3 = Sqrt(3.0)

c/    Calculate the equivalent atomic current of each beamline in A:
c/    (Recall that pbeam is in MW and ebeam in keV!):

      do  ib = 1, nbeams
	 do ie = 1, 3
            bmcur(ie,ib) = 1.0e3*fbpwr(ie,ib)*float(ie)*
     .	       pbeam(ib)/ebeam(ib)
            vbeam(ie,ib) = 4.3770e5*Sqrt(ebeam(ib)/(float(ie)*amb))
         enddo
      enddo

c/    Initialize arrays to avoid problems with some compilers:

      do i = 1, nrho
         snBeamDD(i) = 0.0
         snBeamDT(i) = 0.0
         jnbTot(i) = 0.0
	 beamFus(i) = 0.0
	 beamDDFus(i) = 0.0
	 beamDTFus(i) = 0.0
	 beamFusDTHe4(i) = 0.0
	 beamFusDDHe3(i) = 0.0
	 beamFusDDp(i) = 0.0
	 beamFusDDt(i) = 0.0
	 beamDens(i) = 0.0
	 beamPress(i) = 0.0
	 do ib = 1, nbeams
	    jnb(i,ib) = 0.0
	    do ie = 1, 3
	       jnbie(i,ie,ib) = 0.0
	       srcfast(i,ie,ib) = 0.0
	       fNBion(i,ie,ib) = 0.0
	       fNBelec(i,ie,ib) = 0.0
            enddo
         enddo
      enddo

      nrhom1 = nrho - 1
      do  i = 1, nrhom1
	 epsilon = rho(i)*rminor/(rmajor + rminor*shift(i))
         dne20 = elecDensity(i)
	 zte = elecTemp(i)
	 zti = ionTemp(i)
         call coulomb (cloge,dne20,zte,0.0,amb,0.0,0.0,0.0,1)
         taus = 0.2*amb*zte**1.5/(cloge*dne20*zbeam**2)

c/    Calculate trapped electron correction factor:

         trapfact = (1.55 + 0.85/zef(i))*Sqrt(epsilon) -
     x              (0.20 + 1.55/zef(i))*epsilon
         factor  = 1.0 - (1.0 - trapfact)*zbeam/zef(i)
	 sumjnbib = 0.0
	 sumsDDib = 0.0
	 sumsDTib = 0.0
	 sumFusib = 0.0
	 sumDDFusib = 0.0
	 sumDTFusib = 0.0
	 sumFusDTHe4 = 0.0
	 sumFusDDHe3 = 0.0
	 sumFusDDp = 0.0
	 sumFusDDt = 0.0
	 sumdnbib = 0.0
	 sumPreib = 0.0
         do ib = 1,  nbeams
	    sumjnbie = 0.0
	    do ie = 1, 3
	       if (fbpwr(ie,ib).ne.0.0) then
                  energy = ebeam(ib)/float(ie)
                  sumbrack = 0.0
                  sumhat = 0.0
                  do  isp = 1, nions
                     ami = atw(isp)
                     zz  = znum(isp)
                     call coulomb (clogi,dne20,zte,ami,amb,zz,zbeam,
     .    	       energy,2)
                     sumbrack = sumbrack + dni(i,isp)*zz**2*clogi/ami
                     sumhat = sumhat + dni(i,isp)*zz*zz*clogi/amb
                  enddo
                  zbr = sumbrack/(cloge*elecDensity(i))
                  zhat = sumhat/sumbrack

c/    Critical energy for fast ion slowing down:

                  ecrit = 14.8*(zbr**(2./3.))*amb*zte
                  yc = Sqrt(ecrit/energy)
                  call qsimp(fb, 0., 1., reslt)
                  capke = reslt*(1. + yc**3)**(zhat/3.)
                  tauf = taus*Log((1.0+(energy/ecrit)**1.5)/
     x                   (1.0+(zti/ecrit)**1.5))/3.0

c/    Calculate fast and net current densities (A/m2):

                  srcfast(i,ie,ib) = bmcur(ie,ib) *
     x		    (1.0 - shinethru(ie,ib)) * hofr(i,ie,ib)/volume
                  jfast = zbeam*srcfast(i,ie,ib)*taus*vbeam(ie,ib)*
     x                    capke*pitchangl(i,ie,ib)
	          jnbie(i,ie,ib) = factor*jfast
                  sumjnbie = sumjnbie + jnbie(i,ie,ib) 

                  if (inbfus.eq.1) then
                  
c/    Calculate rates of beam-plasma interactions:

                     rcoef = 1.36593e13*srcfast(i,ie,ib)*taus/
     x                       Sqrt(amb)
                     if (ibion.eq.jdeut) then              ! D injection
                        if (jdeut.ne.0) then
                           comfact = 0.50
                           ireact = 1                      ! D(d,n)3He
                           call qsimp (frate,zti,energy,rint)
                           rrddn = rcoef*dni(i,jdeut)*rint
                           ireact = 2                      ! D(d,p)T
                           call qsimp (frate,zti,energy,rint)
                           rrddp = rcoef*dni(i,jdeut)*rint
                        endif
                        if (jhe3.ne.0) then                 ! D(3He,p)4He
                           comfact = 3.0/5.0
                           ireact = 3
                           call qsimp (frate,zti,energy,rint)
                           rrdhe3 = dni(i,jhe3)*rcoef*rint
                        endif
                        if (jtrit.ne.0) then                ! D(t,n)4He
                           comfact = 3.0/5.0
                           ireact = 4
                           call qsimp (frate,zti,energy,rint)
                           rrdt = dni(i,jtrit)*rcoef*rint
                        endif
                     else if (ibion.eq.jhe3) then          ! He3 injection
                        comfact = 2.0/5.0
                        ireact = 3
                        call qsimp (frate,zti,energy,rint)
                        rrdhe3 = dni(i,jdeut)*rcoef*rint
                     endif
                     sumsDDib = sumsDDib + rrddn
                     sumsDTib = sumsDTib + rrdt
		     sumDDFusib = sumDDFusib + 1.6022e-19 * 
     .                   (eddn*rrddn + eddp*rrddp)
		     sumDTFusib = sumDTFusib + 1.6022e-19 * 
     .                   edtn*rrdt
                     sumFusib = sumFusib + 1.6022e-19*(
     .                      eddn*rrddn + eddp*rrddp + edhe3*rrdhe3 +
     .                      edtn*rrdt)
		     sumFusDTHe4 = sumFusDTHe4 + 1.6022e-19*
     .                  rrdt*edtnhe4
		     sumFusDDHe3 = sumFusDDHe3 + 1.6022e-19*
     .                  rrddn*eddnhe3
		     sumFusDDp = sumFusDDp + 1.6022e-19*
     .                  rrddp * eddpp
		     sumFusDDt = sumFusDDt + 1.6022e-19*
     .                  rrddp * eddpt
		     
                  endif

c/    Calculate fast ion density (#/m^3):
                  sumdnbib = sumdnbib + srcfast(i,ie,ib)*tauf/eCharge

c/    Calculate fast ion pressure (in Pa):

                  xcr = Sqrt(energy/ecrit)
                  term1 = Log((xcr**2+2.*xcr+1.)/(xcr**2-xcr+1))/6.0
                  term2 = (atan((2.*xcr-1)/root3) + pi/6.)/root3
                  term = xcr**2/2. + term1 - term2
                  bcoef = 2.*ecrit*1.6022e-16*taus/3.
                  sumPreib = sumPreib +
     .                     srcfast(i,ie,ib)*bcoef*term/eCharge

c/    Calculate power division between electrons and ions:

		  fNBion(i,ie,ib) = 2.0*(term2 - term1) / (xcr**2)
		  fNBelec(i,ie,ib) = 1.0 - fNBion(i,ie,ib)
               endif
	    enddo

	    jnb(i,ib) = sumjnbie
	    sumjnbib = sumjnbib + sumjnbie
         enddo
	 snBeamDD(i) = sumsDDib
	 snBeamDT(i) = sumsDTib
	 jnbTot(i) = sumjnbib
	 beamFus(i)  = sumFusib
	 beamDTFus(i) = sumDTFusib
	 beamDDFus(i) = sumDDFusib
	 beamFusDTHe4(i) = sumFusDTHe4
	 beamFusDDHe3(i) = sumFusDDHe3
	 beamFusDDp(i) = sumFusDDp
	 beamFusDDt(i) = sumFusDDt
	 beamDens(i) = sumdnbib
	 beamPress(i) = sumPreib
      enddo

      return
      end


c/////////////////////////////////////////////////////////////////////////
c/
c/ NAME
c/    fb
c/
c/ DESCRIPTION
c/    Calculates the distribution function for the fast ions
c/
c/ PARAMETERS
c/    y   : normalized fast ion energy
c/
c/ RETURNS
c/    fb  : value of distribution function
c/
c/
c/////////////////////////////////////////////////////////////////////////

      real function fb(y)

      real y, yc, zhat
      common/intg/yc,zhat
      
      fb=(y**3 / (y**3 + yc**3))**(zhat / 3.0 + 1.0)
      
      return
      end

      subroutine coulomb(clog, dne, te, ami, amf, zi, zf, efast, isp)

c/    This subroutine calculates the Coulomb logarithms due to
c/    collisions between fast ions and plasma ions and electrons
c/    Reference: 
c/    D.R. Mikkelsen, C.E. Singer, Nuclear Technol./Fusion 4, 237 (1983)

c/    Input variables:
c/    dne    : electron density in units of 10**14 cm-3
c/    te     : electron temperature in keV
c/    ami    : plasma ion mass number (amu)
c/    amf    : fast ion mass number
c/    zi     : plasma ion atomic number
c/    zf     : fast ion atomic number
c/    efast  : fast ion energy (keV)
c/    isp    : isp=1 -> electron coulomb logarithm
c/             isp=2 -> beam-plasma ion coulomb logarithm
c/    Output :
c/    clog   : coulomb logarithm
c/    
c/    07/07/98: Fixed bug in calculation of electron logarithm
      
      implicit none
      integer isp
      real ami, amf, clog, dne, efast, elim, te, te10, 
     .	   zi, zf
      te10 = te/10.0
      elim = 100.*amf*(zf*zi)**2

      if (isp.eq.1) then
         clog = 17.0 + alog10((te10)/sqrt(dne))
      else
         if (efast.le.elim) then
            clog = 25.4 + alog10((efast*1.e-3*ami/(zf*zi*(ami+amf)))*
     x        sqrt(te10/dne))
         else if (efast.gt.elim) then
            clog = 23.7 + alog10((ami/(ami+amf))*sqrt(te10*amf*efast
     x        *1.e-3/dne))
         endif
      endif

      return
      end

      subroutine sigfit(ebeam,dene,te,denz, sig)
c-----------------------------------------------------------------------
c.....author:
c       Charles D. Boley
c       Lawrence Livermore National Laboratory
c       L-574
c       Livermore, CA 94550
c       (415) 423-7365
 
c     version of 3/11/92
 
c.....This subroutine computes the neutral beam stopping cross section,
c     for a hydrogenic beam, as a function of beam energy, electron
c     density, electron temperature, and impurity density.  Four
c     impurities (He, C, O, Fe) are allowed.
 
c     The code employs a fit based on results of the author's beam
c     penetration code.  The latter code contains the detailed atomic
c     cross sections recommended at the IAEA Specialists' Meeting on
c     Required Atomic Data Base for Neutral Beam Penetration in Large
c     Tokamaks (Vienna, 4/89).  The fit applies for beam energies from
c     10 keV/amu to 10 MeV/amu and for all densities and electron
c     temperatures of interest.
 
c     The fit is independent of the ion temperature and hence does not
c     distinguish among hydrogen ion isotopes in the plasma.  (The actual
c     cross sections were evaluated at Ti = 15 keV.)  The ion temperature
c     has little effect provided that it is small compared to the beam
c     energy per amu.  (This condition normally is a triviality, except
c     perhaps for the 1/3 energy component of a deuterium beam.)  The
c     following table gives an idea of the variation with ion temperature
c     at low beam energy, for injection into a pure H plasma with
c     dene=1.e14 and Te=10 keV (energies in keV; cross sections in this
c     table in units of 10**-16 cm**2):
 
c     ebeam  sig(Ti=1)  sig(Ti=15)  sig(Ti=30)  sig(fit)
c       10     11.43       9.96        8.91      11.18
c       30      6.06       5.12        4.71       5.35
c       50      3.57       3.56        3.39       3.75
c      100      2.09       2.11        2.09       2.28
 
c     The fit was evaluated with B(perpendicular component) = 5 T.
c     Variations of the magnetic field have an insignificant effect on
c     the stopping cross section.
 
c     Accuracy of fit: rms error about 2.5%
c                      max error about 12%
 
c     Input parameters --
c       ebeam: beam energy per amu (keV/amu) -- 10. .le. ebeam .le. 1.e4
c       dene:  electron density (cm**-3) -- 1.e12 .le. dene .le. 1.e15
c       te:    electron temperature (keV) -- te .ge. 1.
c       denz:  impurity densities (cm**-3) -- array of dimension 4
c         denz(1): He
c         denz(2): C
c         denz(3): O
c         denz(4): Fe
c         Note: denz(i)=0. is permissible
c     Output parameter --
c       sig:   beam stopping cross section (cm**2)
c
c     Modified by John Mandrekas (GIT) for the SUPERCODE
c     New version with fits valid from lower beam energies (10 keV)
c     03/27/92, John Mandrekas, GIT

      implicit none
      integer mz, mt1, mt2, mt3
      parameter(mz=4, mt1=4, mt2=3, mt3=2)
      integer i, nth1, nth2, nth3, ntz1(mz), ntz2(mz), ntz3(mz),
     .        iinit
      real A1(mt1,mt2,mt3), A2(mt1,mt2,mt3,mz)
      common/cfit/A1, nth1, nth2, nth3, A2, ntz1, ntz2, ntz3
      real s1, ebeam, te, sig, sum, dene, poly3f,
     .     denz(mz), s2(mz), az(mz), xx(3)
      data az/2.,6.,8.,26./
      data iinit/0/
      if(iinit.eq.0) then
        iinit=1
        call initfit
      endif
 
      xx(1) = alog(ebeam)
      xx(2) = alog(dene/1.e13)
      xx(3) = alog(te)
      s1 = poly3f(A1,mt1,mt2,mt3,xx(1),nth1,xx(2),nth2,xx(3),nth3)
      do i = 1, 4
         if(denz(i).gt.0.) then
            s2(i)=poly3f(A2(1,1,1,i),mt1,mt2,mt3,xx(1),ntz1(i),
     .            xx(2),ntz2(i),xx(3),ntz3(i))
         else
           s2(i)=0.
         endif
      enddo

      sum=0.0
      do i = 1, 4
         sum = sum + (denz(i)*az(i)*(az(i)-1.)/dene)*s2(i)
      enddo

      sig = (1.e-16/ebeam)*exp(s1)*(1.+sum)

      return
      end
 
      subroutine initfit
c-----------------------------------------------------------------------
c-----New version, with different fits valid from lower beam energies
c-----Received from C. Boley, LLNL
c-----Modified for  use by the SuperCode, John Mandrekas, 03/27/92

      implicit none
      integer mz, mt1, mt2, mt3
      parameter(mz=4, mt1=4, mt2=3, mt3=2)
      integer i, nth1, nth2, nth3, ntz1(mz), ntz2(mz), ntz3(mz)
      real A1(mt1,mt2,mt3), A2(mt1,mt2,mt3,mz)
      common/cfit/A1, nth1, nth2, nth3, A2, ntz1, ntz2, ntz3
 
c..   pure plasma
      nth1 = 3
      nth2 = 3
      nth3 = 2
      A1(1,1,1)= 3.95e+00
      A1(1,1,2)= 1.60e-02
      A1(1,2,1)=-3.84e-02
      A1(1,2,2)=-5.98e-03
      A1(1,3,1)=-3.10e-03
      A1(1,3,2)=-1.09e-03
      A1(2,1,1)= 3.67e-01
      A1(2,1,2)=-2.15e-02
      A1(2,2,1)= 3.07e-02
      A1(2,2,2)= 1.78e-03
      A1(2,3,1)= 3.16e-03
      A1(2,3,2)= 3.47e-04
      A1(3,1,1)=-9.95e-03
      A1(3,1,2)= 6.19e-04
      A1(3,2,1)=-2.36e-03
      A1(3,2,2)=-1.67e-04
      A1(3,3,1)=-1.31e-04
      A1(3,3,2)=-2.28e-05
 
      do i = 1, 4
         ntz1(i) = 4
         ntz2(i) = 2
         ntz3(i) = 2
      enddo
 
c..   He
      i=1
      A2(1,1,1,i)=-1.76e+00
      A2(1,1,2,i)=-2.90e-01
      A2(1,2,1,i)= 5.43e-02
      A2(1,2,2,i)= 1.04e-02
      A2(2,1,1,i)= 7.49e-01
      A2(2,1,2,i)= 1.57e-01
      A2(2,2,1,i)=-3.74e-02
      A2(2,2,2,i)=-6.70e-03
      A2(3,1,1,i)=-7.28e-02
      A2(3,1,2,i)=-2.45e-02
      A2(3,2,1,i)= 6.11e-03
      A2(3,2,2,i)= 1.14e-03
      A2(4,1,1,i)= 2.05e-03
      A2(4,1,2,i)= 1.34e-03
      A2(4,2,1,i)=-2.82e-04
      A2(4,2,2,i)=-5.42e-05
 
c..   C
      i=2
      A2(1,1,1,i)=-1.89e-01
      A2(1,1,2,i)=-3.22e-02
      A2(1,2,1,i)= 5.43e-02
      A2(1,2,2,i)= 3.83e-03
      A2(2,1,1,i)=-1.41e-03
      A2(2,1,2,i)= 8.98e-03
      A2(2,2,1,i)=-3.34e-02
      A2(2,2,2,i)=-1.97e-03
      A2(3,1,1,i)= 3.10e-02
      A2(3,1,2,i)= 7.43e-04
      A2(3,2,1,i)= 5.08e-03
      A2(3,2,2,i)= 1.96e-04
      A2(4,1,1,i)=-2.54e-03
      A2(4,1,2,i)=-4.21e-05
      A2(4,2,1,i)=-2.20e-04
      A2(4,2,2,i)= 8.32e-07
 
c..   O
      i=3
      A2(1,1,1,i)=-1.07e-01
      A2(1,1,2,i)=-3.36e-02
      A2(1,2,1,i)= 4.90e-02
      A2(1,2,2,i)= 3.77e-03
      A2(2,1,1,i)=-3.72e-02
      A2(2,1,2,i)= 1.11e-02
      A2(2,2,1,i)=-2.89e-02
      A2(2,2,2,i)=-1.84e-03
      A2(3,1,1,i)= 3.34e-02
      A2(3,1,2,i)= 7.20e-06
      A2(3,2,1,i)= 4.14e-03
      A2(3,2,2,i)= 1.64e-04
      A2(4,1,1,i)=-2.50e-03
      A2(4,1,2,i)= 1.08e-05
      A2(4,2,1,i)=-1.65e-04
      A2(4,2,2,i)= 2.45e-06
 
c..   Fe
      i=4
      A2(1,1,1,i)= 5.46e-02
      A2(1,1,2,i)=-3.89e-02
      A2(1,2,1,i)= 1.71e-02
      A2(1,2,2,i)=-7.35e-04
      A2(2,1,1,i)=-8.97e-02
      A2(2,1,2,i)= 2.36e-02
      A2(2,2,1,i)=-7.46e-03
      A2(2,2,2,i)= 9.94e-04
      A2(3,1,1,i)= 2.96e-02
      A2(3,1,2,i)=-4.71e-03
      A2(3,2,1,i)= 2.52e-04
      A2(3,2,2,i)=-3.05e-04
      A2(4,1,1,i)=-1.75e-03
      A2(4,1,2,i)= 3.63e-04
      A2(4,2,1,i)= 4.10e-05
      A2(4,2,2,i)= 2.37e-05

      return
      end
 
      real function poly3f(a,ndim1,ndim2,ndim3,
     .  x1,n1,x2,n2,x3,n3)

c-----Modified by j. mandrekas, for the SuperCode
c-----New version with new fits, 03/27/92

      implicit none

      integer ndim1, ndim2, ndim3, n1,n2, n3, i, i1, i2, i3
      real a(ndim1,ndim2,ndim3)
      real x1, x2, x3, y1(4), y2(4), y3(4)

      y1(1)=1.0
      do i = 2, n1
         y1(i)=y1(i-1)*x1
      enddo

      y2(1)=1.0
      do i = 2, n2
         y2(i) = y2(i-1)*x2
      enddo

      y3(1)=1.0
      do i = 2, n3
         y3(i) = y3(i-1)*x3
      enddo

      poly3f=0.0
      do i1 = 1, n1
         do i2 = 1, n2
            do i3 = 1, n3
               poly3f = poly3f + a(i1,i2,i3)*y1(i1)*y2(i2)*y3(i3)
            enddo
         enddo
      enddo

      return
      end

      subroutine qsimp(func,a,b,s)

c-----This subroutine returns as -s- the integral of the function -func-
c-----from -a- to -b-. The variable -eps- determines the desired fractional
c-----accuracy, and the maximum number of steps is 2**(jmax-1). Integration
c-----is performed by Simpson's rule. The routine has been taken from the 
c-----book "Numerical recipes" , by W. Press et al.
c-----Adapted for the SuperCode, John Mandrekas, GIT, 11-15-91

      implicit none

      external func

      integer j, jmax
      real a, b, eps, func, os, ost, s, st
      data eps/1.e-4/,jmax/100/

      ost=-1.e30
      os= -1.e30
      do  j = 1, jmax
         call trapzd(func,a,b,st,j)
         s=(4.*st-ost)/3.0
         if(abs(s-os).lt.eps*abs(os)) return
         os=s
         ost=st
      enddo

      return
      end


      subroutine trapzd(func,a,b,s,n)

      implicit none
      integer it, j, n
      real a, b, func, del, sum, s, tnm, x

      if (n.eq.1) then
         s=0.5*(b-a)*(func(a)+func(b))
         it=1
      else
         tnm=it
         del=(b-a)/tnm
         x=a+0.5*del
         sum=0.0
         do  j = 1, it
            sum=sum+func(x)
            x=x+del
         enddo
         s=0.5*(s+(b-a)*sum/tnm)
         it=2*it
      endif

      return
      end

c/////////////////////////////////////////////////////////////////////////
c/    
c/     NAME
c/        frate
c/    
c/     DESCRIPTION
c/    
c/        This function calculates the integrand needed in the calculation
c/    of the beam-plasma fusion reaction rates. The fusion cross sections
c/    are taken from the recent work of H. Bosch, IPP I/252, 1990 and
c/    are expressed in mbarns. The cross sections are given as functions
c/    of the COM energy (in keV). The Lab energy -e- is converted to
c/    the COM energy, -ecm- by multiplying with the factor -comfact-
c/    which is evaluated in the calling routine.
c/    Created by Andrew Renalds, GIT, 01-23-91
c/    Modified for use in the SuperCode by John Mandrekas, GIT, 01-07-92.
c/    Information regarding the different coefficients for the different
c/    energy regions of the D(3He,p)4He, and D(t,n)4He reactions moved
c/    from the calling routine (fastIons), here to hide unecessary details
c/    and fix problems at low energies, JM, 01-11-92
c/
c/ PARAMETERS
c/    e  : LAB energy in keV
c/
c/ RETURNS
c/    frate: the integrand for the velocity space integration
c/
c/////////////////////////////////////////////////////////////////////////

      real function frate(e)
      
      implicit none

      real a1(6), a2(6), a3(6), a4(6), a5(6), bg(6)
      real b1(6), b2(6), b3(6), b4(6)
      real ecrit, comfact, e, ecm, edtmax, sn, sd, s, sigv, dfterm,
     .     dhe3lim, dtlim, fresult
      integer ii, ireact
      common/sigma/ecrit, comfact, ireact


c/    e     : energy in the lab frame, in keV
c/    ecm   : energy in the COM frame, in keV
c/    ecrit : critical energy, in keV
c/    ii    : reaction index as follows:
c/      1 = coefficients for the D(d,n)3He   reaction 0.5-4900keV
c/      2 = coefficients for the D(d,p)T     reaction 0.5-5000keV
c/      3 = coefficients for the D(3He,p)4He reaction 0.3-900keV
c/      4 = coefficients for the D(3He,p)4He reaction 900-4800keV
c/      5 = coefficients for the D(t,n)4He   reaction 0.5-550keV
c/      6 = coefficients for the D(t,n)4He   reaction 550-4700keV

      data a1(1),a2(1),a3(1) / 5.3701e4,3.3027e2,-1.2706e-1 /
      data a4(1),a5(1) / 2.9327e-5,-2.5151e-9 /
      data b1(1),b2(1) / 0.0, 0.0 /
      data b3(1),b4(1) / 0.0, 0.0 /
      data bg(1) / 31.3970 /

      data a1(2),a2(2),a3(2) / 5.5576e4,2.1054e2,-3.2638e-2 /
      data a4(2),a5(2) / 1.4987e-6,1.8181e-10 /
      data b1(2),b2(2) / 0.0, 0.0 /
      data b3(2),b4(2) / 0.0, 0.0 /
      data bg(2) / 31.3970 /

      data a1(3),a2(3),a3(3) / 5.7501e6,2.5226e3,4.5566e1 /
      data a4(3),a5(3) / 0.0, 0.0 /
      data b1(3),b2(3) / -3.1995e-3,-8.5530e-6 /
      data b3(3),b4(3) / 5.9014e-8, 0.0 /
      data bg(3) / 68.7508 /

      data a1(4),a2(4),a3(4) / -8.3993e5, 0.0, 0.0 /
      data a4(4),a5(4) / 0.0, 0.0 /
      data b1(4),b2(4) / -2.6830e-3,1.1633e-6 /
      data b3(4),b4(4) / -2.1332e-10,1.4250e-14 /
      data bg(4) / 68.7508 /

      data a1(5),a2(5),a3(5) / 6.927e4,7.454e8,2.05e6 /
      data a4(5),a5(5) / 5.2002e4, 0.0 /
      data b1(5),b2(5) / 63.8,-0.995 /
      data b3(5),b4(5) / 6.981e-5,1.728e-4 /
      data bg(5) / 34.3827 /

      data a1(6),a2(6),a3(6) / -1.4714e6, 0.0, 0.0 /
      data a4(6),a5(6) / 0.0, 0.0 /
      data b1(6),b2(6) / -8.4127e-3,4.7983e-6 /
      data b3(6),b4(6) / -1.0748e-9,8.5184e-14 /
      data bg(6) / 34.3827 /

      data edtmax /4700.00/, dhe3lim/900.0/, dtlim/550.0/

      ecm = comfact*e                ! convert to COM energy
c-----check energy regions:
      if (ireact.eq.1) ii = 1        ! D(d,n)he3
      if (ireact.eq.2) ii = 2        ! D(d,p)T
      if (ireact.eq.3) then          ! D(he3,p)he4
         if (ecm.le.dhe3lim) ii = 3
         if (ecm.gt.dhe3lim) ii = 4
      endif
      if (ireact.eq.4) then          ! D(t,n)he4
         if (ecm.le.dtlim) ii = 5
         if (ecm.gt.dtlim) ii = 6
         if(ecm.gt.edtmax) ecm = edtmax
      endif

c-----Calculate cross section and integrand:
      sn = a1(ii)+ecm*(a2(ii)+ecm*(a3(ii)+ecm*(a4(ii)+ecm*a5(ii))))
      sd = 1.0+ecm*(b1(ii)+ecm*(b2(ii)+ecm*(b3(ii)+ecm*b4(ii))))
      s = sn/sd
      sigv = s/(ecm*exp(bg(ii)/Sqrt(ecm)))         ! in mbarns!
      dfterm = 1.0/(Sqrt(e)*(1.0+(ecrit/e)**1.5))
      fresult = sigv*dfterm

      frate = fresult
      
      return
      end

c//////////////////////////////////////////////////////////////////////////
c/
c/ NAME
c/    sinteg
c/
c/ DESCRIPTION
c/    This routine calculates the attenuation of a beamlet in the 
c/    plasma along its path, from R=r1 to R=r2. The integral is 
c/    calculated using Gaussian integration formulas.
c/    Written by John Mandrekas, GIT, for the SuperCode
c/    Revisions:
c/    04-14-92, John Mandrekas:
c/       Modified to handle beams with three energy components more
c/       efficiently.
c/    02-07-92, John Mandrekas:
c/       Modified to work with new and faster GETRHO
c/
c/ PARAMETERS
c/    r1, r2:  Lower and upper limits of integration
c/    alongs:  The result of the integration along the chord for
c/             each of the energy components
c/
c////////////////////////////////////////////////////////////////////////////

      subroutine sinteg (r1, r2, alongs)

      implicit none
      include 'nbparams.inc'
      include 'BeamsLoc.inc'
      include 'nbplasma.inc'

c/    Local Variable Declarations:
c/    ---------------------------      
      real r1, r2, alongs(3)
      integer ie, is, jlo 
      real u1, u2, u2pu1, u2mu1, u, sums1, sums2, sums3, 
     .     sterm, rprime, rhotest, stest, stoler, usqr
      real ovlambda(3)

      data stoler /1.0e-5/
           
c/    Coordinate transformation, u = rb/R:

      u1 = rb/r1
      u2 = rb/r2
      u2pu1 = u2 + u1
      u2mu1 = u2 - u1

c/    Avoid very small integration intervals:

      stest = abs(u2mu1)
      if (stest.lt.stoler) then
         do ie = 1, 3
            alongs(ie) = 0.0
         enddo
         return
      endif

      sums1 = 0.0
      sums2 = 0.0
      sums3 = 0.0
      do is = 1, ns
         u = 0.5*(u2mu1*ss(is) + u2pu1)
         usqr = u**2
         rprime = rb/u
         sterm = (1.0/usqr)*Sqrt((1.0 - ss(is)**2)/
     .                 (1.0 - usqr))
         call getrho (rprime, rhotest, jlo)
         do ie = 1, 3
            if (fbpwr(ie,ibeam).ne.0.0) then
               ovlambda(ie) = omfp(jlo,ie,ibeam) +
     .         (omfp(jlo+1,ie,ibeam) - omfp(jlo,ie,ibeam))*
     .         (rhotest - rho(jlo))/(rho(jlo+1) - rho(jlo))
            endif
         enddo
         sums1 = sums1 + ovlambda(1)*sterm
         sums2 = sums2 + ovlambda(2)*sterm
         sums3 = sums3 + ovlambda(3)*sterm
      enddo
      
      alongs(1) = -0.5*rb*u2mu1*ws*sums1
      alongs(2) = -0.5*rb*u2mu1*ws*sums2
      alongs(3) = -0.5*rb*u2mu1*ws*sums3
      
      return
      end

      real function sig_olson (eb, zq)

c///////////////////////////////////////////////////////////////////////
c/
c/    This function calculates the total electron loss cross section 
c/    (charge exchange and ionization)  between hydrogenic neutrals
c/    and heavy impurities.
c/    Written by John Mandrekas, GIT, 08/31/99
c/
c/    Reference:
c/    ---------
c/    R.E. Olson, et. al, Phys. Rev. Letters, 41 (1978) 163.
      
c/    Input:
c/    ------
c/    eb  : neutral energy in keV/amu
c/    zq  : ion charge state

c/    Output:
c/    ------
c/    sig_olson : Stopping cross section in cm^2
c/
c///////////////////////////////////////////////////////////////////////
      
      implicit none
      real eb, zq, sig_loss, factr

      factr = 32.0 * zq / eb
      sig_loss = 4.6e-16 * zq * factr * (1.0 - exp(-1.0/factr))

      sig_olson = sig_loss

      return
      end

c/////////////////////////////////////////////////////////////////////////
c/
c/ NAME
c/    Beams_mfp
c/
c/ DESCRIPTION
c/    This subroutine calculates the inverse mean free path of
c/    hydrogenic neutrals in a plasma using the beam stopping cross
c/    section parametrization by C. Boley (Nucl. Fusion 29, 2125, 1989)
c/    Version 0.00, John Mandrekas, GIT, 06-25-91
c/    Updated fits (SIGFIT91), 03/27/92
c/
c/ PARAMETERS
c/    None
c/ 
c/ RETURNS
c/    Nothing
c/
c/////////////////////////////////////////////////////////////////////////

      subroutine Beams_mfp
      
      implicit none
      
      include 'nbparams.inc'
      include 'BeamsLoc.inc'
      include 'nbplasma.inc'

      real sig_olson

c/    Local variable declarations:
c/    ---------------------------      
      integer i, ie, iz, izq 
      real te, dene, eb_amu, sig, sigzol, zq


c/    Get ready to call the subroutine SIGFIT:

      do i = 1, nrho
         te = elecTemp(i)
         dene = 1.0e14*elecDensity(i)
	 if (ihe4.ne.0) then
	    denz(1) = 1.0e14*dni(i,ihe4)
         else
	    denz(1) = 0.0
         endif
	 if (icarb.ne.0) then
	    denz(2) = 1.0e14*dni(i,icarb)
         else
	    denz(2) = 0.0
         endif
	 if (ioxy.ne.0) then
	    denz(3) = 1.0e14*dni(i,ioxy)
         else
	    denz(3) = 0.0
         endif
	 if (iFe.ne.0) then
	    denz(4) = 1.0e14*dni(i,iFe)
         else
	    denz(4) = 0.0
         endif

c/    Calculate inverse mean free path for each energy group if required:

c/    For the impurity species NOT included in Boley's routine, 
c/    calculate stopping cross section using Olson's formula and
c/    add to the total inverse mean free path:

	 do ie = 1, 3
	    if (fbpwr(ie,ibeam).ne.0.0) then
	       eb_amu = ebkev/(ie*ab)
    	       call sigfit (eb_amu, dene, te, denz, sig)
	       omfp(i,ie,ibeam) = 1.0e16 * elecDensity(i) * sig

	       if (inonb.NE.0) then
	          sigzol = 0.0
		  do iz = 1, inonb
		     izq = nonbindx(iz)
		     zq = znum(izq)
		     sigzol = sigzol + dni(i,izq)*sig_olson(eb_amu,zq)
		  enddo
		  omfp(i,ie,ibeam) = omfp(i,ie,ibeam) + 1.0e16*sigzol
	       endif

            endif

         enddo   ! End of DO loop over energy components

      enddo      ! End of DO loop over radial points

      return
      end

      subroutine hofrho (nbeams, ebeam, pbeam, rtang, nbshape, bwidth,
     .   bheigh, nbptype, bgaussR, bgaussZ, bzpos, hofr, shinethru,
     .   pNBAbsorb, pNBLoss, pNBAbsorbTot, pNBLossTot)

c/////////////////////////////////////////////////////////////////////////
c/
c/ NAME
c/    hofrho
c/
c/ DESCRIPTION
c/    This is the main routine for the calculation of the NB
c/    deposition profile using the diffuse beam model. This routine
c/    calls the appropriate routines for the R-Z integration on the
c/    face of the beam.
c/    Written by John Mandrekas, GIT, for the SuperCode
c/    Version 0.00, 08/08/91
c/    Modified for NTCC, 08/29/00, John Mandrekas
c/    References:
c/
c/    J.A. Rome, J.D. Callen, J.F. Clarke, Nucl. Fusion, 14, 141 (1974)
c/    H.C. Howe, 'Physics Models in the Tokamak Transport Code PROCTR',
c/                ORNL report, ORNL/TM-9537, 1985
c/    J. Mandrekas, 'Physics Models and User's Guide for the Neutral
c/                   Beam Module of the SuperCode,' GTFR-102, August 1992
c/
c/////////////////////////////////////////////////////////////////////////
c/
c/    Input parameters (notice, that other parameters needed by this 
c/    routine are passed by the BeamsLoc.inc and nbplasma.inc common
c/    blocks.
c/
c/    nbeams      : Number of beamlines
c/    ebeam(ib)   : Beam energy of each beamline (keV)
c/    pbeam(ib)   : Beam power of each beamline  (MW)
c/    rtang(ib)   : Tangency radius of each beamline (m)
c/    nbshape(ib) : Flag determining the cross section shape of each
c/                  beamline. Available optios are 0 for circlular
c/                  and 1 for rectangular.
c/    bwidth(ib)  : Width (or diameter for circular) of each beamline (m)
c/    bheigh(ib)  : Height of each beamline (m)
c/    nbptype(ib) : Flag for power distribution in the beam cross section.
c/                  0 : uniform distribution
c/                  1 : Gaussian (circular) or bi-Gaussian (rectangular)
c/    bgaussR(ib) : Gaussian width (radial direction for circular beams,
c/                  horizontal direction for rectangular beams). (m)
c/    bgaussZ(ib) : Gaussian width in vertical direction for rectangular
c/                  beams (m)
c/    bzpos(ib)   : Position of peak in Z direction for bi-Gaussian
c/                  power distribution (rectangular shapes only) (m)
c/ 
c/    Calculated Quantities:
c/    ---------------------      
c/    hofr(i,ie,ib)    : Neutral beam deposition profile for beam ib,
c/                       energy component ie, at grid point i. Notice
c/                       that the deposition profile is normalized to 1!
c/    shinethru(ie,ib) : Beam shinethrough for beam ib and energy
c/                       component ie.
c/    pNBLoss(ib)      : Neutral beam power lost per beamline (MW).
c/    pNBAbsorb(ib)    : Neutral beam power absorbed per beamline (MW).
c/    pNBAbsorbTot     : Total NB power absorbed in the plasma.
c/    pNBLossTot       : Total NB power lost.


      implicit none
      include 'nbparams.inc'
      include 'nbplasma.inc'
      include 'BeamsLoc.inc'
      include 'nbconsts.inc'

      integer nbeams
      integer nbshape(maxBeams), nbptype(maxBeams)
      real pNBAbsorbTot, pNBLossTot
      real ebeam(maxBeams), pbeam(maxBeams), rtang(maxBeams), 
     .     bwidth(maxBeams), bheigh(maxBeams), bgaussR(maxBeams), 
     .     bgaussZ(maxBeams), bzpos(maxBeams), pNBAbsorb(maxBeams),
     .     pNBLoss(maxBeams)
      real hofr(mxrho, 3, maxBeams), shinethru(3, maxBeams)

c/    Local variable declarations:
c/    ---------------------------
      integer i, nrhom1, ie, ib
      real erf
      real cnorm, fact, fact2, pi2, rtest1, rtest2, rlimit, rhoMax,
     .     prterm, pzterm1, pzterm2, pnbtotal, sumhofr, sumlossib
      real factr(3), hplus(3), hmnus(3), ksiplus(3), ksiminus(3)

      save rhoMax
      
      data rhoMax /0.99/

      pi2 = pi**2
      
c/    Calculate parameters for Gaussian integrations:
c/    ----------------------------------------------
      call gaussWts (nz, wz, sz)
      call gaussWts (nr, wr, sr)
      call gaussWts (ns, ws, ss)
     
      elong0 = elong(1) 
      elonga = elong(nrho)
      nrhom1 = nrho - 1
      rhoSurf = rminor*rhoMax

c/    Start do loop over beamlines:
c/    ----------------------------
      do ib = 1, nbeams
         ibeam = ib
         ebkev = ebeam(ib)
         rtan  = rtang(ib)
         shape = nbshape(ib)
         width = bwidth(ib)
         rbeam = 0.5 * width
         height= bheigh(ib)
         gaussR= bgaussR(ib)
         gaussZ= bgaussZ(ib)
         zpos  = bzpos(ib)
         ptype = nbptype(ib)

c/    Calculate beam stopping cross sections:
c/    --------------------------------------
         call Beams_mfp
      
c/    Normalization factor for current distribution:
c/    ---------------------------------------------
c/    Case for circular beam:

         if (shape.eq.0) then
            if (ptype.eq.0) cnorm = 1.0/(pi*rbeam**2)
            if (ptype.eq.1) then
               fact  = rbeam/gaussR
               fact2 = fact**2      
               cnorm = pi*gaussR**2*(1.0 - exp(-fact2))
               cnorm = 1.0/cnorm
             endif
c/    Case for rectangular beam:

         else if (shape.eq.1) then
            if (ptype.eq.0) cnorm = 1.0/(height*width)
            if (ptype.eq.1) then
               prterm = 0.5*width/gaussR
               pzterm1= 0.5*(height-2.0*zpos)/gaussZ
               pzterm2= 0.5*(height+2.0*zpos)/gaussZ
               cnorm = pi*gaussR*gaussZ*erf(prterm)*(
     .              erf(pzterm1) + erf(pzterm2))
               cnorm = 1.0/cnorm
            endif
         endif
      
c/    Getting ready for the big DO loop:
c/    ---------------------------------
         rtest1 = rtan - rbeam
         do iflux = 1, nrhom1
            rhoi  = rminor*rho(iflux)
            elongr = elong(iflux)
            delong = elong_rho(iflux)/rminor
            shft   = shift(iflux)*rminor
            dshft  = shift_rho(iflux)
            rtest2 = rmajor + shft + rhoi
           
c/    Check to see if there is intersection with this flux surface:

            if (rtest1.ge.rtest2) then
               do ie = 1, 3
                  hofr (iflux,ie,ib) = 0.0
                  pitchangl(iflux,ie,ib) = 0.0
               enddo
            else
            
c/    Limit of rho/vprime at the center:                     

               if (rhoi.eq.0.0) then
                  rlimit = 4.0*pi2*elong0*(rmajor + rminor*shift(1))
                  do ie = 1, 3
                     factr(ie) = 2.0*volume*omfp(1,ie,ib)/rlimit
                  enddo
               else
                  do ie = 1, 3
                     factr(ie) = (2.0*rhoi*volume / vpr(iflux)) *
     .                     omfp(iflux,ie,ib)
                  enddo
               endif
           
c/    Calculate contributions from outside intersections:

               sgn = 1.0
               call zinteg
               do ie = 1, 3
                  hplus(ie) = alongz(ie)
                  ksiplus(ie) = avksi(ie)
               enddo

c/    Calculate contributions from inside intersections:
               
               sgn = -1.0
               call zinteg
               do ie = 1, 3
                  hmnus(ie) = alongz(ie)
                  ksiminus(ie) = avksi(ie)
               enddo
 
c/    Total HOFR and average pitch angle at flux zone -iflux- :

               do ie = 1, 3
                  if (fbpwr(ie,ib).ne.0.0) then
                     hofr(iflux,ie,ib) = cnorm*factr(ie)*
     .                  (hplus(ie) + hmnus(ie))
                     pitchangl(iflux,ie,ib) = (ksiplus(ie) +
     .                 ksiminus(ie))/ (hplus(ie) + hmnus(ie))
                  else
                     hofr(iflux,ie,ib) = 0.0
                     pitchangl(iflux,ie,ib) = 0.0
                  endif
               enddo
            endif
         enddo

c/    Set deposition profile at the edge = 0

         do ie = 1, 3
            hofr(nrho,ie,ib) = 0.0
            pitchangl(nrho,ie,ib) = 0.0
         enddo
      enddo

c/    Calculate beam shinethrough, and other quantities of interest:
c/    -------------------------------------------------------------
      do ib = 1, nbeams
         do ie = 1, 3
            sumhofr = 0.0
            do i = 1, nrho
               sumhofr = sumhofr + hofr(i,ie,ib)*dv(i)
            enddo
            shinethru(ie,ib) = 1.0 - sumhofr/volume
         enddo
      enddo

c/    Renormalize the deposition profile, so that its volume integral
c/    divided by the total plasma volume is equal to one:
c/    ---------------------------------------------------
      do ib = 1, nbeams
         do ie = 1, 3
            if (shinethru(ie,ib).ne.1.0) then
              do i = 1, nrho
                hofr(i,ie,ib) = hofr(i,ie,ib) / (1.0 - shinethru(ie,ib))
              enddo
            endif
            if (shinethru(ie,ib).lt.0.0) shinethru(ie,ib) = 0.0
         enddo
      enddo

c/    Calculate the total NB power loss (shinethrough or missed
c/    the plasma, which is also part of shinethrough in this model).
c/    -------------------------------------------------------------
      pNBLossTot = 0.0
      pnbtotal =  0.0
      do ib = 1, nbeams
         sumlossib = 0.0
         pnbtotal = pnbtotal + pbeam(ib) 
         do ie = 1, 3
            sumlossib = sumlossib + pbeam(ib) * fbpwr(ie,ib) 
     .        * shinethru(ie,ib)
         enddo
         pNBLoss(ib) = sumlossib
         pNBAbsorb(ib) = pbeam(ib) - pNBLoss(ib)
         pNBLossTot = pNBLossTot + pNBLoss(ib)
      enddo
      pNBAbsorbTot = pnbtotal - pNBLossTot

      return
      end                
